/*
    This program is a clone à Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Ami.h"

Ami::Ami()
{
    initSDLSurface(1);
    initSDLRect(1);
}

Ami::~Ami()
{

}

void Ami::setNumNarration(int NN) {numNarration = NN;}
int Ami::getNumNarration() {return numNarration;}

void Ami::initType()
{
    // Valeur de déplacement par défaut ; préciser dans l'init si ces valeurs sont différentes
    setVitesseDeplacementSurX(1);
    setVitesseDeplacementSurY(1);
    initCompteurAnim();

    // Pour test
    switch(getType())
    {
        case 1:
            setFeuilleSprite(personnage1);
            break;

        case 2:
            setFeuilleSprite(personnage2);
            break;

        case 3:
            setFeuilleSprite(personnage3);
            break;

        case 4:
            setFeuilleSprite(personnage4);
            break;

        case 5:
            setFeuilleSprite(personnage5);
            break;

        case 6:
            setFeuilleSprite(personnage6);
            break;

        case 7:
            setFeuilleSprite(personnage7);
            break;

        case 8:
            setFeuilleSprite(personnage8);
            break;

        case 9:
            setFeuilleSprite(personnage9);
            break;

        case 10:
            setFeuilleSprite(personnage10);
            break;

        case 11:
            setFeuilleSprite(personnage11);
            break;

        case 12:
            setFeuilleSprite(personnage12);
            break;

        case 13:
            setFeuilleSprite(personnage13);
            break;

        case 14:
            setFeuilleSprite(personnage14);
            break;

        case 15:
            setFeuilleSprite(personnage15);
            break;

        case 16:
            setFeuilleSprite(personnage16);
            break;

        case 17:
            setFeuilleSprite(personnage17);
            break;

        case 18:
            setFeuilleSprite(personnage18);
            break;

        case 19:
            setFeuilleSprite(personnage19);
            break;

        case 20:
            setFeuilleSprite(personnage20);
            break;

        case 21:
            setFeuilleSprite(personnage21);
            break;

        case 22:
            setFeuilleSprite(personnage22);
            break;

        case 23:
            setFeuilleSprite(personnage23);
            break;

        case 24:
            setFeuilleSprite(personnage24);
            break;

        case 25:
            setFeuilleSprite(personnage25);
            break;

        case 26:
            setFeuilleSprite(personnage26);
            break;

        case 27:
            setFeuilleSprite(personnage27);
            break;

        case 28:
            setFeuilleSprite(personnage28);
            break;

        case 29:
            setFeuilleSprite(personnage29);
            break;

        case 30:
            setFeuilleSprite(personnage30);
            break;

        case 31:
            setFeuilleSprite(personnage31);
            break;

        case 32:
            setFeuilleSprite(personnage32);
            break;

        default:
            break;

    }

    switch(getType())
    {
        case 1:
        case 7:
        case 12:
        case 13:
        case 14:
        case 17:
        case 19:
        case 23:
        case 25:
            setDimensionX(16);
            setDimensionY(25);
            break;

        case 2:
        case 11:
        case 18:
            setDimensionX(16);
            setDimensionY(24);
            break;

        case 3:
        case 8:
        case 15:
        case 32:
            setDimensionX(16);
            setDimensionY(23);
            break;

        case 4:
        case 27:
        case 30:
        case 31:
            setDimensionX(16);
            setDimensionY(17);
            break;

        case 5:
            setDimensionX(17);
            setDimensionY(16);
            break;

        case 6:
            setDimensionX(15);
            setDimensionY(16);
            break;

        case 9:
            setDimensionX(16);
            setDimensionY(27);
            break;

        case 10:
        case 20:
            setDimensionX(16);
            setDimensionY(26);
            break;


        case 16:
            setDimensionX(32);
            setDimensionY(48);
            break;

        case 21:
            setDimensionX(17);
            setDimensionY(25);
            break;

        case 22:
            setDimensionX(16);
            setDimensionY(29);
            break;

        case 24:
            setDimensionX(16);
            setDimensionY(21);
            break;

        case 26:
            setDimensionX(39);
            setDimensionY(30);
            break;

        case 28:
            setDimensionX(25);
            setDimensionY(35);
            break;

        case 29:
            setDimensionX(21);
            setDimensionY(27);
            break;

        default:
            break;
    }
}

void Ami::intelligenceArtificielle()
{
    // Dans cette partie, on ne modifie pas l'orientation du pnj, sauf éventuellement s'il ne se déplace pas.

    // On s'assure que le personnage doit bien être affiché avant de l'animer (sinon, bug possible ; à confirmer)
    //if(getPositionX() > -1 || getPositionX() < 241 || getPositionY() > -1 || getPositionY() < 321)
    //cout << "compteurDeplacementAutomatique" << getCompteurDeplacement() <<endl;
    {
        if(getPauseAnimation()) {setImmobiliser();}
        else {incrementationCompteurDeplacement();}

        switch(getType())
        {
            // Personnages amis pouvant se déplacer
            // Partie à diviser ensuite selon les cas de figure
            case 1:
            case 3:
            case 5:
            case 6:
            case 11:
            case 13:
            case 14:
            case 15:
            case 23:
                setOrientation(1);
                break;

            // Autres personnages amis immobiles
            // Partie à diviser ensuite selon les cas de figure
            case 2:
            case 4:
            case 7:
            case 8:
            case 9:
            case 10:
            case 12:
            case 16:
            case 17:
            case 18:
            case 19:
            case 20:
            case 21:
            case 22:
            case 24:
            case 25:
            case 26:
            case 27:
            case 28:
            case 29:
            case 30:
            case 31:
            case 32:
                setOrientation(0); // L'orientation est fixée à "0" car il n'y a qu'une seule orientation possible pour ces personnages
                break;

            default:
                break;
        }
    }
}

SDL_Rect Ami::selectionSprite(bool pause)
{
    SDL_Rect rectAmi;

    switch(getType())
    {
            // Personnages amis pouvant se déplacer
            // Partie à diviser ensuite selon les cas de figure
            case 1:
            case 3:
            case 5:
            case 6:
            case 11:
            case 13:
            case 14:
            case 15:
            case 23:
                // Donné à titre d'exemple ---> à adapter
                rectAmi = getSDLRect(getType() + 200,getOrientation(),0);
                break;

            // Autres personnages amis immobiles
            // Partie à diviser ensuite selon les cas de figure
            case 2:
            case 4:
            case 7:
            case 8:
            case 9:
            case 10:
            case 12:
            case 16:
            case 17:
            case 18:
            case 19:
            case 20:
            case 21:
            case 22:
            case 24:
            case 25:
            case 26:
            case 27:
            case 28:
            case 29:
            case 30:
            case 31:
            case 32:
                // Donné à titre d'exemple ---> à adapter
                rectAmi = getSDLRect(getType() + 200,getOrientation(),0);
                break;

        default:
            break;
    }

    return rectAmi;
}
