/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef CLAVIER_H_INCLUDED
#define CLAVIER_H_INCLUDED

#include "position.h"
#include "Hero.h"
#include "Texte.h"
#include "Menu.h"
#include "Carte.h"

// Gère le clavier en fonction des différentes phases du programme (sélection type de partie, nouvelle partie, partie existante, partie en cours, début, fin)
class Clavier
{
    public:

        Clavier();
        virtual ~Clavier();

        void ecouteEventMenuSelectionActif(SDL_Event event,bool &done,int &numPartie,bool &effacerPartie,bool &validation);
        void ecouteEventMenuCreationNouvellePartie(SDL_Event event,bool &done,bool &retour, bool &valider, bool &suppr, int &x, int &y);
        void ecouteEventMenuOptionsPartie(SDL_Event event,bool &done,bool &retour);
        void ecouteEventMenuSuppressionPartie(SDL_Event event,bool &done,int &numPartie,bool &retour,bool & validation);
        void ecouteEventDeroulementPartie(SDL_Event event,bool &done,Hero &joueur,Texte &lecture,Menu &menuJeu,Carte &map,bool &quitter,bool &valider);

        void setFlecheHaut(bool FH);
        bool getFlecheHaut();
        void setFlecheBas(bool FB);
        bool getFlecheBas();
        void setFlecheGauche(bool FG);
        bool getFlecheGauche();
        void setFlecheDroite(bool FD);
        bool getFlecheDroite();


        bool* getFleches();
        void setFlechesInactives();
        //void applicationDerniereToucheEnfoncee();

        void setDerniereToucheEnfoncee(int DTE);
        int getDerniereToucheEnfoncee();
        void setAvantDerniereToucheEnfoncee(int ADTE);
        int getAvantDerniereToucheEnfoncee();

    protected:

    private:

        bool flecheHaut; // Bascule à vrai tant que la touche est enfoncée.
        bool flecheBas; // Bascule à vrai tant que la touche est enfoncée.
        bool flecheGauche; // Bascule à vrai tant que la touche est enfoncée.
        bool flecheDroite; // Bascule à vrai tant que la touche est enfoncée.
        bool fleches[4]; // Tableau contenant les quatre directions et leur état (0 : Haut ; 1 : Bas ; 2 : Gauche ; 3 : Droite)

        int derniereToucheEnfoncee; // Mémorise le numéro de la dernière touche enfoncée.
        int avantDerniereToucheEnfoncee; // Mémorise le numéro de l'avant dernière touche enfoncée.
};




#endif // CLAVIER_H_INCLUDED
