/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DEROULEMENTPARTIE_H_INCLUDED
#define DEROULEMENTPARTIE_H_INCLUDED

#include "position.h"
#include "Clavier.h"
#include "Carte.h"
#include "Hero.h"
#include "Ami.h"
#include "Statut.h"
#include "ImagesPartie.h"
#include "Texte.h"
#include "Menu.h"
#include "Donjon.h"

// Gère le déroulement de l'histoire en fonction des actions du joueur et les menus.
class DeroulementPartie : public ImagesPartie
{
    public:

        DeroulementPartie();
        virtual ~DeroulementPartie();

        void setQuitter(bool Q);
        bool getQuitter();

        void setPlan(bool P);
        bool getPlan();

        void setMenuEtatItem(bool MEI);
        bool getMenuEtatItem();

        void setPartieEnCours(bool PEC);
        bool getPartieEnCours();
        void gestionPartieEnCours(SDL_Surface* screenPartieEnCours, Mix_Chunk* musique,bool* sortieProgramme);

        void setDecalageSurX(int X);
        int getDecalageSurX();
        void setDecalageSurY(int Y);
        int getDecalageSurY();

        void chargerSauvegarde(int NP);
        void enregistrerSauvegarde();

        void setAvancementQuete(int AQ,int numQuete);
        int* getAvancementQuetes();

        int getNumDonjonEnCours(int numCarte);

        void setDonjonActif(int DA);
        int getDonjonActif();

    protected:

    private:

        void preTraitementAffichagePartieEnCours(bool* validation, Mix_Chunk* musique,bool* sortieProgramme);
            void testLiensCarte(int decalageSurX,int decalageSurY,Hero* joueur, Carte* map);
            void gestionMusiqueDeFond(Mix_Chunk* musique, Carte* map, int NP);
        void majStats();
        void afficherPartieEnCours(SDL_Surface* screenPartieEnCours);

        bool quitter; // Utilisé pour afficher le menu "quitter"
        bool plan; // Utilisé pour afficher le plan du donjon ou la carte du monde
        bool menuEtatItem; // Utilisé pour afficher le menu de sélection des items et de visualisation des états du joueur (nombre de quarts de cœur, équipements, objets spéciaux...)
        bool partieEnCours; // Si vrai, indique que la partie est en cours
        int numPartie; // Numéro de la partie en cours. Utilisé pour connaître la sauvegarde à mettre à jour en fin de partie.
        Clavier* clav; // Gère les actions liées aux événements lors du déroulement de la partie
        SDL_Event event; // Pour la gestion des événements SDL
        Carte* map; // Contient la carte où le joueur se trouve
        int decalageSurX; // Permet de situer la portion de carte à afficher
        int decalageSurY; // Permet de situer la portion de carte à afficher
        Hero* joueur; // Personnage principal du jeu, celui que l'on incarne et que l'on contrôle
        Statut* stat; // Informations (sur la partie en cours) affichées en permanence à l'écran
        Menu* menuJeu; // Menu de sélection des armes / de visualisation de l'état de la partie (quêtes, niveau d'équipement)
        Texte* lecture; // Texte à afficher à l'écran (lecture pancarte ou écoute autre pnj)
        int* avancementQuetes; // Etat d'avancement de chaque quête du jeu.
        Donjon* donjon1; // Donjon numéro 1
        int donjonActif; // Contient le numéro du donjon ou se trouve le joueur.

        int fondu; // Pour le fondu en ouverture lors du changement de carte
        string nomMusique; // Mémorise le nom de la musique de fonf en cours de lecture

};



#endif // DEROULEMENTPARTIE_H_INCLUDED
