/*
    This program is a clone à Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "Donjon.h"

Donjon::Donjon(int ND)
{
    setNumDonjon(ND);
    init();
}

Donjon::~Donjon()
{
    //dtor
}

void Donjon::setNumDonjon(int ND) {numDonjon = ND;}
int Donjon::getNumDonjon() {return numDonjon;}

void Donjon::setPlanTrouve(bool PT) {planTrouve = PT;}
bool Donjon::getPlanTrouve() {return planTrouve;}

void Donjon::setSalleBoss(int SB) {salleBoss = SB;}
int Donjon::getSalleBoss() {return salleBoss;}

void Donjon::setNbClesPossedees(int NCP) {nbClesPossedees = NCP;}
int Donjon::getNbClesPossedees() {return nbClesPossedees;}

void Donjon::setCleBossPossedees(bool CBP) {cleBossPossedee = CBP;}
bool Donjon::getCleBossPossedees() {return cleBossPossedee;}

void Donjon::setBossVaincu(bool BV) {bossVaincu = BV;}
bool Donjon::getBossVaincu() {return bossVaincu;}

void Donjon::setMiniMap(int X, int Y, int Z, blocDonjon D)
{
    if(X > 0 && X < 11 && Y > 0 && Y < 11 && Z > -3 && Z < 3)
    {
        miniMap[X][Y][Z] = D;
    }
}
blocDonjon Donjon::getMiniMap(int X, int Y, int Z)
{
    if(X > 0 && X < 11 && Y > 0 && Y < 11 && Z > -3 && Z < 3)
    {
        return miniMap[X][Y][Z];
    }

    return miniMap[X][Y][Z]; // TEMPORORAIRE (faire un contrôle avant de lancer la fonction plutôt)
}

void Donjon::init()
{
    // Attention : la salle du boss doit obligatoirement être l'une des cartes du donjon
    switch (getNumDonjon())
    {
        case 1:
            cartesDonjon.push_back(100);
            cartesDonjon.push_back(101);
            cartesDonjon.push_back(102);
            cartesDonjon.push_back(103);
            cartesDonjon.push_back(104);
            cartesDonjon.push_back(105);
            cartesDonjon.push_back(106);
            cartesDonjon.push_back(107);
            cartesDonjon.push_back(108);
            cartesDonjon.push_back(109);
            cartesDonjon.push_back(110);
            cartesDonjon.push_back(111);
            cartesDonjon.push_back(112);
            cartesDonjon.push_back(113);
            cartesDonjon.push_back(114);
            cartesDonjon.push_back(115);
            cartesDonjon.push_back(116);

            setSalleBoss(116);
            break;

        default:
            break;
    }
}

bool Donjon::getCarteDansDonjon(int NC)
{
    bool carteDansDonjon = false;
    //list<int>::iterator it;

    //for(it=cartesDonjon.begin();it != cartesDonjon.end();it++)
    //{
        //cout << *it << " " ;
        //if(*it == 100) cartesDonjon = true;
    //}

    //cout << endl;
    if(binary_search(cartesDonjon.begin(),cartesDonjon.end(),NC))
    {
        carteDansDonjon = true;
    }

    return carteDansDonjon;
}
