/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DONJON_H
#define DONJON_H

#include "position.h"
#include "ImagesPartie.h"

// Les donjons sont des lieux particuliers, regroupant généralement plusieurs cartes et ayant un fonctionnement particulier (gestion d'objets propres au donjon, avancement dans le donjon, ...).
class Donjon : public ImagesPartie
{
    public:

        Donjon(int ND);
        virtual ~Donjon();

        int getNumDonjon();

        void setPlanTrouve(bool PT);
        bool getPlanTrouve();
        int getSalleBoss();

        void setNbClesPossedees(int NCP);
        int getNbClesPossedees();

        void setCleBossPossedees(bool CBP);
        bool getCleBossPossedees();

        void setBossVaincu(bool BV);
        bool getBossVaincu();

        void setMiniMap(int X, int Y, int Z, blocDonjon D);
        blocDonjon getMiniMap(int X, int Y, int Z);

        bool getCarteDansDonjon(int NC); // vrai si la carte est dans le donjon testé

    protected:

    private:

        void setNumDonjon(int ND); // La fonction doit être appelée lors de la création du donjon
        void init(); // Fonction destinée à initialiser le donjon (ajout de cartes, etc...) ; La fonction doit être appelée lors de la création du donjon
        void setSalleBoss(int SB); // La fonction doit être appelée lors de l'initialisation du donjon

        int numDonjon; //Numéro du donjon
        bool planTrouve; // Vrai si le plan du donjon a été trouvé.
        int salleBoss; // Indique sur quelle carte se trouve le boss du donjon.
        int nbClesPossedees; // Nombre de clés du donjon collectées et pas encore utilisées.
        bool cleBossPossedee; // Indique si la clé ouvrant la porte menant au boss du donjon est en possession du joueur.
        bool bossVaincu; // Vrai si le boss du donjon est vaincu.
        blocDonjon miniMap[10][10][5]; // Contient le plan du donjon.
        list<int> cartesDonjon; // Liste contenant les numéros de carte du donjon

};

#endif // DONJON_H
