/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Ennemi.h"

Ennemi::Ennemi()
{
    setAttaque(false);
    setTouche(false);

    initSDLSurface(1);
    initSDLRect(1);

    // init des sons emis par le pnj ennemi
	sonsPnjEnnemi[0] = Mix_LoadWAV("sons/killenemy.ogg"); // Chargement du son de l'ennemi tué
	sonsPnjEnnemi[1] = Mix_LoadWAV("sons/hitenemy.ogg"); // Chargement du son de l'ennemi tué
}

Ennemi::~Ennemi()
{

}

void Ennemi::setEnergie(int E)
{
    energie = E;
    if(energie <= 0) Mix_PlayChannel(4,sonsPnjEnnemi[0], 0); // Joue le son de l'ennemi se faisant tuer
}
int Ennemi::getEnergie() {return energie;}
void Ennemi::setEnergieMax(int EM)
{
    energieMax = EM;
    setEnergie(EM); // Lorsque l'on fixe le niveau d'énergie max d'un ennemi, son niveau d'énergie est au max
}
int Ennemi::getEnergieMax() {return energieMax;}

void Ennemi::setAttaque(bool A)
{
    attaque = A;
}
bool Ennemi::getAttaque() {return attaque;}
void Ennemi::setTouche(bool T)
{
    touche = T;
    if(touche)
    {
        setEnergie(getEnergie() - 1);
        if(getEnergie() > 0) Mix_PlayChannel(4,sonsPnjEnnemi[1], 0); // Joue le son de l'ennemi se faisant toucher
    }
    setCompteurDeplacement(-1);
}
bool Ennemi::getTouche() {return touche;}

void Ennemi::setItemsActifs(list<bool> IA) {itemsActifs = IA;}
list<bool> Ennemi::getItemsActifs() {return itemsActifs;}


//void Ennemi::initType(SDL_Surface* E)
void Ennemi::initType()
{
    setEnergieMax(1); // Par défaut, le niveau d'énergie max des ennemis est d'une unité

    // Pour test
    switch(getType())
    {
        case 1:
            setFeuilleSprite(ennemi1);
            break;

        case 2:
            setFeuilleSprite(ennemi2);
            break;

        case 3:
            setFeuilleSprite(ennemi3);
            break;

        case 4:
            setFeuilleSprite(ennemi4);
            break;

        case 5:
            setFeuilleSprite(ennemi5);
            break;

        case 6:
            setFeuilleSprite(ennemi6);
            break;

        case 7:
            setFeuilleSprite(ennemi7);
            break;

        case 8:
            setFeuilleSprite(ennemi8);
            break;

        case 9:
            setFeuilleSprite(ennemi9);
            break;

        case 10:
            setFeuilleSprite(ennemi10);
            break;

        case 11:
            setFeuilleSprite(ennemi11);
            break;

        case 12:
            setFeuilleSprite(ennemi12);
            break;

        case 13:
            setFeuilleSprite(ennemi13);
            break;

        case 14:
            setFeuilleSprite(ennemi14);
            break;

        case 15:
            setFeuilleSprite(ennemi15);
            break;

        case 16:
            setFeuilleSprite(ennemi16);
            break;

        case 17:
            setFeuilleSprite(ennemi17);
            break;

        case 18:
            setFeuilleSprite(ennemi18);
            break;

        case 19:
            setFeuilleSprite(ennemi19);
            break;

        case 20:
            setFeuilleSprite(ennemi20);
            break;

        case 21:
            setFeuilleSprite(ennemi21);
            break;

        case 22:
            setFeuilleSprite(ennemi22);
            break;

        case 23:
            setFeuilleSprite(ennemi23);
            break;

        case 24:
            setFeuilleSprite(ennemi24);
            break;

        case 25:
            setFeuilleSprite(ennemi25);
            break;

        case 26:
            setFeuilleSprite(ennemi26);
            break;

        case 27:
            setFeuilleSprite(ennemi27);
            break;

        case 28:
            setFeuilleSprite(ennemi28);
            setEnergieMax(10);
            break;

        case 29:
            setFeuilleSprite(ennemi29);
            break;

        case 30:
            setFeuilleSprite(ennemi30);
            break;

        case 31:
            setFeuilleSprite(ennemi31);
            break;

        case 32:
            setFeuilleSprite(ennemi32);
            break;

        case 33:
            setFeuilleSprite(ennemi33);
            break;

        case 34:
            setFeuilleSprite(ennemi34);
            break;

        case 35:
            setFeuilleSprite(ennemi35);
            break;

        case 36:
            setFeuilleSprite(ennemi36);
            break;

        case 37:
            setFeuilleSprite(ennemi37);
            break;

        case 38:
            setFeuilleSprite(ennemi38);
            break;

        case 39:
            setFeuilleSprite(ennemi39);
            break;

        case 40:
            setFeuilleSprite(ennemi40);
            break;

        case 41:
            setFeuilleSprite(ennemi41);
            break;

        case 42:
            setFeuilleSprite(ennemi42);
            break;

        case 43:
            setFeuilleSprite(ennemi43);
            break;

        case 44:
            setFeuilleSprite(ennemi44);
            break;

        case 45:
            setFeuilleSprite(ennemi45);
            break;

        case 46:
            setFeuilleSprite(ennemi46);
            setEnergieMax(2);
            break;

        case 47:
            setFeuilleSprite(ennemi47);
            setEnergieMax(3);
            break;

        case 48:
            setFeuilleSprite(ennemi48);
            setEnergieMax(5);
            break;

        case 49:
            setFeuilleSprite(ennemi49);
            break;

        case 50:
            setFeuilleSprite(ennemi50);
            break;

        case 51:
            setFeuilleSprite(ennemi51);
            break;

        case 52:
            setFeuilleSprite(ennemi52);
            break;

        default:
            break;

    }

    // Valeur de déplacement par défaut ; préciser dans l'init si ces valeurs sont différentes
    setVitesseDeplacementSurX(1);
    setVitesseDeplacementSurY(1);
    initCompteurAnim();

    switch(getType())
    {
        case 1: // Squelette
        case 5: //
        case 29:
        case 37:
            setDimensionX(16);
            setDimensionY(26); // dimensions : x = 16 et y = 26 (77*52) -> (64*52) ; E(5)
            break;

        case 2: // Garde aquatique
            setDimensionX(21);
            setDimensionY(26);
            break;

        case 3: // Bestiole cyclope
            setDimensionX(28);
            setDimensionY(17);
            break;

        case 4: // Plante vivante
        case 17: //
        case 27: //
        case 52: //
            setDimensionX(16); // dimensions : x = 16 et y = 17 (48*17) ; E(4;17)
            setDimensionY(17); // dimensions : x = 16 et y = 17 (64*68) ; E(27)
            // dimensions : x = 16 et y = 17 (32*68) ; E(52)
            break;

        case 6: //
            setDimensionX(16); // dimensions : x = 16 et y = 37 (176*37) ; E(6)
            setDimensionY(37);
            break;

        case 7: //
        case 10: //
        case 20: //
            setDimensionX(16); // dimensions : x = 16 et y = 16 (64*32) ; E(7)
            setDimensionY(16); // dimensions : x = 16 et y = 16 (32*16) ; E(10;20)
            break;

        case 8: //
        case 9: //
        case 16: //
        case 30: //
        case 41: //
            setDimensionX(16); // dimensions : x = 16 et y = 24 (64*48) ; E(8;9;16;30;41) P(11)
            setDimensionY(24);
            break;

        case 11: //
            setDimensionX(16); // dimensions : x = 16 et y = 21 (64*21) ; E(11)
            setDimensionY(21);
            break;

        case 12: // fantôme
            setDimensionX(17); // dimensions : x = 17 et y = 17 (34*51) ; E(12)
            setDimensionY(17);
            break;

        case 13: //
            setDimensionX(32); // dimensions : x = 32 et y = 15 (96*15) ; E(13)
            setDimensionY(15);
            break;

        case 14: //
            setDimensionX(41); // dimensions : x = 41 et y = 16 (82*16) ; E(14)
            setDimensionY(16);
            break;

        case 15: //
            setDimensionX(24); // dimensions : x = 24 et y = 31 (96*93) ; E(15)
            setDimensionY(31);
            break;

        case 18: //
            setDimensionX(16); // dimensions : x = 16 et y = 14 (48*14) ; E(18)
            setDimensionY(14);
            break;

        case 19: //
            setDimensionX(64); // dimensions : x = 64 et y = 32 (192*32) ; E(19 - BOSS)
            setDimensionY(32);
            break;

        case 21: //
            setDimensionX(16); // dimensions : x = 16 et y = 15 (32*30) ; E(21)
            setDimensionY(15);
            break;

        case 22: //
        case 32: //
            setDimensionX(16); // dimensions : x = 16 et y = 23 (32*23) ; E(22)
            setDimensionY(23); // dimensions : x = 16 et y = 23 (48*23) ; E(32)
            break;

        case 23: //
            setDimensionX(26); // dimensions : x = 26 et y = 17 (52*17) ; E(23)
            setDimensionY(17);
            break;

        case 24: //
            setDimensionX(32); // dimensions : x = 32 et y = 53 (64*53) ; E(24 - BOSS)
            setDimensionY(53);
            break;

        case 25: //
            setDimensionX(28); // dimensions : x = 28 et y = 30 (112*60) ; E(25)
            setDimensionY(30);
            break;

        case 26: //
            setDimensionX(14); // dimensions : x = 14 et y = 16 (42*16) ; E(26)
            setDimensionY(16);
            break;

        case 28: //
            setDimensionX(32); // dimensions : x = 32 et y = 38 (64*38) ; E(28 - BOSS)
            setDimensionY(38);
            break;

        case 31: //
        case 35: //
        case 43: //
            setDimensionX(32); // dimensions : x = 32 et y = 32 (128*32) ; E(31 - BOSS)
            setDimensionY(32); // dimensions : x = 32 et y = 32 (96*32) ; E(35 - BOSS)
             // dimensions : x = 32 et y = 32 (128*96) ; E(43 - BOSS)
            break;

        case 33: //
        case 38: //
            setDimensionX(22); // dimensions : x = 22 et y = 25 (88*50) ; E(33;38)
            setDimensionY(25);
            break;

        case 34: //
        case 39: //
            setDimensionX(24); // dimensions : x = 24 et y = 25 (96*50) ; E(34;39)
            setDimensionY(25);
            break;

        case 40: //
            setDimensionX(54); // dimensions : x = 54 et y = 42 (162*42) ; E(40 - BOSS)
            setDimensionY(42);
            break;

        case 42: //
            setDimensionX(26); // dimensions : x = 26 et y = 19 (52*19) ; E(42)
            setDimensionY(19);
            break;

        case 44: //
            setDimensionX(22); // dimensions : x = 22 et y = 26 (103*52) -> (88*52) ; E(44)
            setDimensionY(26);
            break;

        case 45: //
            setDimensionX(69); // dimensions : x = 69 et y = 76 (276*76) ; E(45 - BOSS)
            setDimensionY(76);
            break;

        case 46: // Gardes
        case 47:
        case 48:
            setDimensionX(22); // dimensions : x = 22 et y = 27 (104*54) -> (88*54) ; E(46;47)
            setDimensionY(27); // dimensions : x = 22 et y = 27 (105*54) -> (88*54) ; E(48)
            break;

        case 50: //
            setDimensionX(52); // dimensions : x = 52 et y = 36 (104*72) ; E(50 - BOSS)
            setDimensionY(36);
            break;

        case 51: //
            setDimensionX(24); // dimensions : x = 24 et y = 28 (48*28) ; E(51)
            setDimensionY(28);
            break;

        default:
            setVitesseDeplacementSurX(0);
            setVitesseDeplacementSurY(0);
            break;
    }

    // fix de bug : évite qu'un ennemi qui explose ne puisse encore bouger
    /*if(E == explo)
    {
        setVitesseDeplacementSurX(0);
        setVitesseDeplacementSurY(0);
    }*/


}



void Ennemi::intelligenceArtificielle()
{
    // Dans cette partie, on ne modifie pas l'orientation du pnj, sauf éventuellement s'il ne se déplace pas.

    // On s'assure que le personnage doit bien être affiché avant de l'animer (sinon, bug possible ; à confirmer)
    //if(getPositionX() > -1 || getPositionX() < 241 || getPositionY() > -1 || getPositionY() < 321)
    //cout << "compteurDeplacementAutomatique" << getCompteurDeplacement() <<endl;
    {
        if(getPauseAnimation())
        {
            setImmobiliser();
        }
        //else if(getPositionX() < 16 || getPositionX() > LARGEUR_ECRAN -16 || getPositionY() < 8 || getPositionY() > HAUTEUR_ECRAN - 24) immobiliser();
        else
        {
            incrementationCompteurDeplacement();
            //setImmobiliser(false);
        }


        if(getCompteurDeplacement() > TEMPS_RECUL + TEMPS_IMMOBILISATION && getTouche())
        {
            setCompteurDeplacement(-1);
            setTouche(false);
            setVitesseDeplacementSurX(1);
            setVitesseDeplacementSurY(1);
        }

        // Modification de la feuille de sprites lorsque l'ennemi doit exploser
        /*if(getCompteurDeplacement() == TEMPS_RECUL && getEnergie() < 1)
        {
            //setFeuilleSprite(explo);
            initType(explo);
        }*/


        switch(getType())
        {
            case 0: // Explosion
                setImmobiliser();
                setVitesseDeplacementSurX(0);
                setVitesseDeplacementSurY(0);
                break;


            case 2: // Garde aquatique
            case 4: // Plante vivante

                    if(getTouche())
                    {
                        setImmobiliser();

                        // Lorsque le PNJ ennemi est touché, il recule dans un premier temps avant de s'immobiliser
                        if(getCompteurDeplacement() > TEMPS_RECUL)
                        {
                            // Dans le cas où l'ennemi n'est plus en phase de recul rapide mais toujours en touché, sa vitesse devient nulle
                            setVitesseDeplacementSurX(0);
                            setVitesseDeplacementSurY(0);
                        }
                        else
                        {
                            // Lorsque le PNJ est dans sa phase de recul lorsqu'il est touché, sa vitesse de déplacement sur chaque axe dépend de son orientation.
                            switch(getOrientation())
                            {
                                case 0:
                                case 1:
                                    setVitesseDeplacementSurX(2);
                                    setVitesseDeplacementSurY(4);
                                    break;
                                case 2:
                                case 3:
                                    setVitesseDeplacementSurX(4);
                                    setVitesseDeplacementSurY(2);
                                    break;
                                default:
                                    break;

                            }
                        }


                        switch(getOrientation())
                        {
                            case 0:
                                setBougeBas(true);
                                if(getDecalageXAvecLeHero() > 0) setBougeDroite(true);
                                else if(getDecalageXAvecLeHero() < 0) setBougeGauche(true);
                                break;
                            case 1:
                                setBougeHaut(true);
                                if(getDecalageXAvecLeHero() > 0) setBougeDroite(true);
                                else if(getDecalageXAvecLeHero() < 0) setBougeGauche(true);
                                break;
                            case 2:
                                setBougeDroite(true);
                                if(getDecalageYAvecLeHero() > 0) setBougeBas(true);
                                else if(getDecalageYAvecLeHero() < 0) setBougeHaut(true);
                                break;
                            case 3:
                                setBougeGauche(true);
                                if(getDecalageYAvecLeHero() > 0) setBougeBas(true);
                                else if(getDecalageYAvecLeHero() < 0) setBougeHaut(true);
                                break;
                            default:
                                break;
                        }

                    }

                    else if(!getAttaque())
                    {
                        switch(getCompteurDeplacement())
                        {
                            case 30:
                                setBougeHaut(false);
                                setBougeBas(false);
                                setBougeGauche(true);
                                setBougeDroite(false);
                                break;
                            case 90:
                                setBougeHaut(true);
                                setBougeBas(false);
                                setBougeGauche(false);
                                setBougeDroite(false);
                                //setOrientation(1);
                                break;
                            case 120:
                                setBougeHaut(false);
                                setBougeBas(false);
                                setBougeGauche(false);
                                setBougeDroite(true);
                                break;
                            case 180:
                                setBougeHaut(false);
                                setBougeBas(true);
                                setBougeGauche(false);
                                setBougeDroite(false);
                                //setOrientation(1);
                                setCompteurDeplacement(-1);
                                break;
                            default:
                                break;
                        }
                    }

                    else
                    {
                        //setImmobiliser(false);

                        if(getDecalageYAvecLeHero() < 0) {setBougeHaut(false); setBougeBas(true);}
                        else if(getDecalageYAvecLeHero() > 0) {setBougeHaut(true); setBougeBas(false);}
                        else {setBougeHaut(false); setBougeBas(false);}

                        if(getDecalageXAvecLeHero() < 0) {setBougeGauche(false); setBougeDroite(true);}
                        else if(getDecalageXAvecLeHero() > 0) {setBougeGauche(true); setBougeDroite(false);}
                        else {setBougeGauche(false); setBougeDroite(false);}

                        if(getCompteurDeplacement() > 30 ) setCompteurDeplacement(-1);
                    }

                break;






            case 1: // Squelette
            case 3: // Bestiole cyclope
            case 5:
            case 6:
            case 7:
            case 8:
            case 9:
            case 11:
            case 12: // fantôme
            case 13:
            case 14:
            case 15:
            case 16:
            case 17:
            case 18:
            case 21:
            case 22:
            case 23:
            case 25:
            case 26:
            case 27:
            case 29:
            case 30:
            case 32:
            case 33:
            case 34:
            case 37:
            case 38:
            case 39:
            case 41:
            case 42:
            case 44:
            case 46: // Garde
            case 47: // Garde
            case 48: // Garde
            case 52:

                if(getTouche())
                {
                    setImmobiliser();

                    // Lorsque le PNJ ennemi est touché, il recule dans un premier temps avant de s'immobiliser
                    if(getCompteurDeplacement() > TEMPS_RECUL)
                    {
                        // Dans le cas où l'ennemi n'est plus en phase de recul rapide mais toujours en touché, sa vitesse devient nulle
                        setVitesseDeplacementSurX(0);
                        setVitesseDeplacementSurY(0);
                    }
                    else
                    {
                        // Lorsque le PNJ est dans sa phase de recul lorsqu'il est touché, sa vitesse de déplacement sur chaque axe dépend de son orientation.
                        switch(getOrientation())
                        {
                            case 0:
                            case 1:
                                setVitesseDeplacementSurX(2);
                                setVitesseDeplacementSurY(4);
                                break;
                            case 2:
                            case 3:
                                setVitesseDeplacementSurX(4);
                                setVitesseDeplacementSurY(2);
                                break;
                            default:
                                break;

                        }
                    }


                    switch(getOrientation())
                    {
                        case 0:
                            setBougeBas(true);
                            if(getDecalageXAvecLeHero() > 0) setBougeDroite(true);
                            else if(getDecalageXAvecLeHero() < 0) setBougeGauche(true);
                            break;
                        case 1:
                            setBougeHaut(true);
                            if(getDecalageXAvecLeHero() > 0) setBougeDroite(true);
                            else if(getDecalageXAvecLeHero() < 0) setBougeGauche(true);
                            break;
                        case 2:
                            setBougeDroite(true);
                            if(getDecalageYAvecLeHero() > 0) setBougeBas(true);
                            else if(getDecalageYAvecLeHero() < 0) setBougeHaut(true);
                            break;
                        case 3:
                            setBougeGauche(true);
                            if(getDecalageYAvecLeHero() > 0) setBougeBas(true);
                            else if(getDecalageYAvecLeHero() < 0) setBougeHaut(true);
                            break;
                        default:
                            break;
                    }

                }

                else if(!getAttaque())
                {
                    switch(getCompteurDeplacement())
                    {
                        case 0:
                            setBougeHaut(false);
                            setBougeBas(false);
                            setBougeGauche(true);
                            setBougeDroite(false);
                            break;
                        case 150:
                            setBougeHaut(false);
                            setBougeBas(false);
                            setBougeGauche(false);
                            setBougeDroite(true);
                            break;
                        case 300:
                            setBougeHaut(false);
                            setBougeBas(false);
                            setBougeGauche(false);
                            setBougeDroite(false);
                            break;
                        case 400:
                            setCompteurDeplacement(-1);
                            break;
                        default:
                            break;
                    }
                }

                else
                {
                    if(getDecalageYAvecLeHero() < 0) {setBougeHaut(false); setBougeBas(true);}
                    else if(getDecalageYAvecLeHero() > 0) {setBougeHaut(true); setBougeBas(false);}
                    else {setBougeHaut(false); setBougeBas(false);}

                    if(getDecalageXAvecLeHero() < 0) {setBougeGauche(false); setBougeDroite(true);}
                    else if(getDecalageXAvecLeHero() > 0) {setBougeGauche(true); setBougeDroite(false);}
                    else {setBougeGauche(false); setBougeDroite(false);}

                    if(getCompteurDeplacement() > 30 ) setCompteurDeplacement(-1);
                }

                break;





            // Boss : garde de pierre
            case 28:


                if(getTouche())
                {
                    setImmobiliser();

                    // Lorsque le PNJ ennemi est touché, il recule dans un premier temps avant de s'immobiliser
                    if(getCompteurDeplacement() > TEMPS_RECUL)
                    {
                        // Dans le cas où l'ennemi n'est plus en phase de recul rapide mais toujours en touché, sa vitesse devient nulle
                        setVitesseDeplacementSurX(0);
                        setVitesseDeplacementSurY(0);
                    }
                    else
                    {
                        // Lorsque le PNJ est dans sa phase de recul lorsqu'il est touché, sa vitesse de déplacement sur chaque axe dépend de son orientation.
                        switch(getOrientation())
                        {
                            case 0:
                            case 1:
                                setVitesseDeplacementSurX(0);
                                setVitesseDeplacementSurY(1);
                                break;
                            case 2:
                            case 3:
                                setVitesseDeplacementSurX(1);
                                setVitesseDeplacementSurY(0);
                                break;
                            default:
                                break;

                        }
                    }


                    switch(getOrientation())
                    {
                        case 0:
                            setBougeBas(true);
                            if(getDecalageXAvecLeHero() > 0) setBougeDroite(true);
                            else if(getDecalageXAvecLeHero() < 0) setBougeGauche(true);
                            break;
                        case 1:
                            setBougeHaut(true);
                            if(getDecalageXAvecLeHero() > 0) setBougeDroite(true);
                            else if(getDecalageXAvecLeHero() < 0) setBougeGauche(true);
                            break;
                        case 2:
                            setBougeDroite(true);
                            if(getDecalageYAvecLeHero() > 0) setBougeBas(true);
                            else if(getDecalageYAvecLeHero() < 0) setBougeHaut(true);
                            break;
                        case 3:
                            setBougeGauche(true);
                            if(getDecalageYAvecLeHero() > 0) setBougeBas(true);
                            else if(getDecalageYAvecLeHero() < 0) setBougeHaut(true);
                            break;
                        default:
                            break;
                    }

                }

                else if(getEnergie() > 3)
                {
                    setVitesseDeplacementSurX(1);
                    setVitesseDeplacementSurY(1);

                    if(getCompteurDeplacement() >= 40) setCompteurDeplacement(-1);
                    else if(getCompteurDeplacement() >= 30)
                    {
                        setBougeHaut(false);
                        setBougeBas(true);
                        setBougeGauche(false);
                        setBougeDroite(true);
                    }
                    else if(getCompteurDeplacement() >= 20)
                    {
                        setBougeHaut(true);
                        setBougeBas(false);
                        setBougeGauche(false);
                        setBougeDroite(true);
                    }
                    else if(getCompteurDeplacement() >= 10)
                    {
                        setBougeHaut(true);
                        setBougeBas(false);
                        setBougeGauche(true);
                        setBougeDroite(false);
                    }
                    else if(getCompteurDeplacement() >= 0)
                    {
                        setBougeHaut(false);
                        setBougeBas(true);
                        setBougeGauche(true);
                        setBougeDroite(false);
                    }
                }

                else
                {
                    setVitesseDeplacementSurX(8);
                    setVitesseDeplacementSurY(4);

                    if(getCompteurDeplacement() >= 40) setCompteurDeplacement(-1);
                    else if(getCompteurDeplacement() >= 20)
                    {
                        setBougeHaut(true);
                        setBougeBas(false);
                        setBougeGauche(false);
                        setBougeDroite(false);
                    }
                    else if(getCompteurDeplacement() >= 0)
                    {
                        setBougeHaut(false);
                        setBougeBas(true);
                        setBougeGauche(false);
                        setBougeDroite(false);
                    }

                }

                break;



            // Boss sorcier 2
            case 40:
                break;



            // Boss sorcier 3
            case 50:
                break;



            // Main géante
            case 51:
                break;



            // Ennemis immobiles
            case 10:
            case 19: // Boss papillon
            case 20:
            case 24: // Boss méduse
            case 31: // Boss sorcier
            case 35: // Boss œuil
            case 36:
            case 43: // Boss nuage rose
            case 45: // Boss scorpion
            case 49:
            default:
                break;

        }

    }

}

SDL_Rect Ennemi::selectionSprite(bool pause, bool interR)
{
    SDL_Rect rectEnnemi;

    // Découpage de la feuille de sprites lorsque l'ennemi doit exploser
    if(getCompteurDeplacement() > TEMPS_RECUL && getEnergie() < 1)
    {
        switch(getType())
        {
            // Seuls les Boss et quelques ennemis particuliers explosent différement

            default:
                rectEnnemi = getSDLRect(26,(((getCompteurDeplacement()-TEMPS_RECUL)/(TEMPS_IMMOBILISATION/6))%7),-1);
                break;
        }

        setIncrCompteurAnim();
    }


    else if(getBougeHaut() || getBougeBas() || getBougeGauche() || getBougeDroite())
    {
        // Gestion du compteur d'animation (incrémentation, pause et initialisation)
        if(getCompteurAnim() > 200) initCompteurAnim();
        if(!pause) setIncrCompteurAnim();

        switch(getType())
        {

            case 1:
            case 2:
            case 5:
            case 7:
            case 8:
            case 9:
            case 15:
            case 16:
            case 21:
            case 25:
            case 27:
            case 29:
            case 30:
            case 32:
            case 33:
            case 34:
            case 37:
            case 38:
            case 39:
            case 41:
            case 43:
            case 44:
            case 46:
            case 47:
            case 48:
            case 50:
            case 52:
                rectEnnemi = getSDLRect(getType() + 100,getOrientation(),((getCompteurAnim()/20)%2));
                break;

            case 3:
            case 4:
            case 6:
            case 10:
            case 11:
            case 13:
            case 14:
            case 18:
            case 19:
            case 20: // cas impossible
            case 22:
            case 23:
            case 24:
            case 26:
            case 28:
            case 31:
            case 35:
            case 40:
            case 42:
            case 45:
            case 51:
                rectEnnemi = getSDLRect(getType() + 100,((getCompteurAnim()/20)%2),0);
                break;

            case 12: // fantôme
                rectEnnemi = getSDLRect(getType() + 100,getOrientation()/3,((getCompteurAnim()/20)%2));
                break;

            case 17: // Pic
                rectEnnemi = getSDLRect(getType() + 100,0,0);
                break;

            default:
                break;

        }
    }


    else
    {
        initCompteurAnim();

        switch(getType())
        {


            case 1:
            case 2:
            case 5:
            case 7:
            case 8:
            case 9:
            case 15:
            case 16:
            case 21:
            case 25:
            case 27:
            case 29:
            case 30:
            case 32:
            case 33:
            case 34:
            case 37:
            case 38:
            case 39:
            case 41:
            case 43:
            case 44:
            case 46:
            case 47:
            case 48:
            case 50:
            case 52:
                rectEnnemi = getSDLRect(getType() + 100,getOrientation(),0);
                break;

            case 3:
            case 4:
            case 6:
            case 10:
            case 11:
            case 13:
            case 14:
            case 18:
            case 19:
            case 22:
            case 23:
            case 24:
            case 26:
            case 28:
            case 31:
            case 35:
            case 40:
            case 42:
            case 45:
            case 51:
                rectEnnemi = getSDLRect(getType() + 100,((getCompteurAnim()/20)%2),0);
                break;

            case 12: // fantôme
                rectEnnemi = getSDLRect(getType() + 100,getOrientation()/3,0);
                break;

            case 17: // Pic
                rectEnnemi = getSDLRect(getType() + 100,0,0);
                break;

            case 20:
                rectEnnemi = getSDLRect(getType() + 100,interR,0);
                break;

            default:
                break;
        }
    }



    return rectEnnemi;
}
