/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ENNEMI_H_INCLUDED
#define ENNEMI_H_INCLUDED

#include "Pnj.h"

// Personnages non joueurs hostiles
class Ennemi : public Pnj
{
    public:

        Ennemi();
        virtual ~Ennemi();

        void setEnergie(int E);
        int getEnergie();
        void setEnergieMax(int EM);
        int getEnergieMax();

        void setAttaque(bool A);
        bool getAttaque();
        void setTouche(bool T);
        bool getTouche();

        void setItemsActifs(list<bool> IA);
        list<bool> getItemsActifs();

        //void initType(SDL_Surface* E);
        void initType();
        void intelligenceArtificielle();
        SDL_Rect selectionSprite(bool pause, bool interR);

    protected:

    private:

        int energie; // Niveau d'énergie en cours de l'ennemi
        int energieMax; // Niveau d'énergie max de l'ennemi lorsqu'il est créé
        bool attaque; // Etat de l'ennemi vis à vis du hero
        bool touche; // Si l'ennemi est touché, il reste un temps prédéterminé dans cet état
        list<bool> itemsActifs; // Contient autant d'éléments que d'items total à disposition du joueur. Un item de type "X" (int) sera efficace si itemsActifs.at(X) est à "true".

        Mix_Chunk* sonsPnjEnnemi[10]; // Création du tableau pointeurs de type Mix_Chunk
};




#endif // ENNEMI_H_INCLUDED
