/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef IMAGESPARTIE_H_INCLUDED
#define IMAGESPARTIE_H_INCLUDED

#include "position.h"

// Classe regroupant les éléments communs au diverses phases de la partie (lors de la sélection de la partie ou de son déroulement)
class ImagesPartie
{
    public:

        ImagesPartie();
        virtual  ~ImagesPartie();

        SDL_Surface* chargerImage( std::string nomFichier );
        void initSDLSurface(int numSelectionSprite);
        void initSDLRect(int numSelectionSprite);
        SDL_Rect getSDLRect(int numSurface,int xRect, int yRect);
        void freeMem(int numSelectionSprite);

    protected:

        // SDL_Surface qui doivent contenir les images à charger

        SDL_Surface* tilesetA; // image du tileset de réfrence partie 1
        SDL_Surface* tilesetB; // image du tileset de réfrence partie 2
        SDL_Surface* tilesetC; // image du tileset de réfrence partie 3
        SDL_Surface* tilesetD; // image du tileset de réfrence partie 4

        SDL_Surface* ennemi1;
        SDL_Surface* ennemi2;
        SDL_Surface* ennemi3;
        SDL_Surface* ennemi4;
        SDL_Surface* ennemi5;
        SDL_Surface* ennemi6;
        SDL_Surface* ennemi7;
        SDL_Surface* ennemi8;
        SDL_Surface* ennemi9;
        SDL_Surface* ennemi10;
        SDL_Surface* ennemi11;
        SDL_Surface* ennemi12;
        SDL_Surface* ennemi13;
        SDL_Surface* ennemi14;
        SDL_Surface* ennemi15;
        SDL_Surface* ennemi16;
        SDL_Surface* ennemi17;
        SDL_Surface* ennemi18;
        SDL_Surface* ennemi19;
        SDL_Surface* ennemi20;
        SDL_Surface* ennemi21;
        SDL_Surface* ennemi22;
        SDL_Surface* ennemi23;
        SDL_Surface* ennemi24;
        SDL_Surface* ennemi25;
        SDL_Surface* ennemi26;
        SDL_Surface* ennemi27;
        SDL_Surface* ennemi28;
        SDL_Surface* ennemi29;
        SDL_Surface* ennemi30;
        SDL_Surface* ennemi31;
        SDL_Surface* ennemi32;
        SDL_Surface* ennemi33;
        SDL_Surface* ennemi34;
        SDL_Surface* ennemi35;
        SDL_Surface* ennemi36;
        SDL_Surface* ennemi37;
        SDL_Surface* ennemi38;
        SDL_Surface* ennemi39;
        SDL_Surface* ennemi40;
        SDL_Surface* ennemi41;
        SDL_Surface* ennemi42;
        SDL_Surface* ennemi43;
        SDL_Surface* ennemi44;
        SDL_Surface* ennemi45;
        SDL_Surface* ennemi46;
        SDL_Surface* ennemi47;
        SDL_Surface* ennemi48;
        SDL_Surface* ennemi49;
        SDL_Surface* ennemi50;
        SDL_Surface* ennemi51;
        SDL_Surface* ennemi52;
        SDL_Surface* personnage1;
        SDL_Surface* personnage2;
        SDL_Surface* personnage3;
        SDL_Surface* personnage4;
        SDL_Surface* personnage5;
        SDL_Surface* personnage6;
        SDL_Surface* personnage7;
        SDL_Surface* personnage8;
        SDL_Surface* personnage9;
        SDL_Surface* personnage10;
        SDL_Surface* personnage11;
        SDL_Surface* personnage12;
        SDL_Surface* personnage13;
        SDL_Surface* personnage14;
        SDL_Surface* personnage15;
        SDL_Surface* personnage16;
        SDL_Surface* personnage17;
        SDL_Surface* personnage18;
        SDL_Surface* personnage19;
        SDL_Surface* personnage20;
        SDL_Surface* personnage21;
        SDL_Surface* personnage22;
        SDL_Surface* personnage23;
        SDL_Surface* personnage24;
        SDL_Surface* personnage25;
        SDL_Surface* personnage26;
        SDL_Surface* personnage27;
        SDL_Surface* personnage28;
        SDL_Surface* personnage29;
        SDL_Surface* personnage30;
        SDL_Surface* personnage31;
        SDL_Surface* personnage32;

        SDL_Surface* bouclier1;
        SDL_Surface* explo;
        SDL_Surface* exploLapin;
        SDL_Surface* link1;
        SDL_Surface* spin;

        SDL_Surface* epee1;
        SDL_Surface* epee3;
        SDL_Surface* epee5;
        SDL_Surface* objets1;

        SDL_Surface* bombe;
        SDL_Surface* boomerang;
        SDL_Surface* buisson;
        SDL_Surface* caisse;
        SDL_Surface* coeurs;
        SDL_Surface* feu;
        SDL_Surface* grappin;
        SDL_Surface* magie;
        SDL_Surface* objets2;
        SDL_Surface* objets4;
        SDL_Surface* plouf;
        SDL_Surface* projectiles1;
        SDL_Surface* projectiles2;
        SDL_Surface* projectiles3;
        SDL_Surface* projectiles4;
        SDL_Surface* projectiles5;
        SDL_Surface* projectiles6;
        SDL_Surface* projectiles7;
        SDL_Surface* projectiles8;
        SDL_Surface* projectiles9;
        SDL_Surface* projectiles10;

        SDL_Surface* bord;
        SDL_Surface* chiffres;
        SDL_Surface* coeur;
        SDL_Surface* inventaire;
        SDL_Surface* level;
        SDL_Surface* objets3;
        SDL_Surface* statut;

        SDL_Surface* font;



        // SDL_Rect permettant de sélectionner les bon sprites des feuilles de sprites

        SDL_Rect explosion[7];

        SDL_Rect persoLink[26][9];
        SDL_Rect persoLinkNage[4][5];
        SDL_Rect persoLinkPorte[4][5];
        SDL_Rect persoLinkSpecial[7];
        SDL_Rect bouclierLink[4];
        SDL_Rect objetALancer[4][3];
        SDL_Rect ombreObjetLance;

        SDL_Rect mailletLink[4][3];
        SDL_Rect baguetteFeuLink[4][3];
        SDL_Rect baguetteGlaceLink[4][3];
        SDL_Rect epeeLink[6][6];
        SDL_Rect epeeLinkLongue[6][6];
        SDL_Rect arcLink[4][2];

        SDL_Rect jaugeLink[2];
        SDL_Rect inscriptionDemiLink;
        SDL_Rect cadreArmeLink;
        SDL_Rect rubisLink;
        SDL_Rect iconeBombeLink;
        SDL_Rect iconeArcLink[2];
        SDL_Rect cleLink;

        SDL_Rect inscriptionVieLink;
        SDL_Rect petitsCoeursLink[3];
        SDL_Rect inventaireMenu[4][6]; // Inventaire des objets affichables dans la liste des items disponible
        SDL_Rect bordMenu[3][3];
        SDL_Rect selecteurItem[2];
        SDL_Rect spritesChiffres[5][4];


        SDL_Rect feuillesExplose[7][4];
        SDL_Rect objetExplose[3];
        SDL_Rect flecheP[4][4];
        SDL_Rect boomR[4][2];
        SDL_Rect feuMagie[3];
        SDL_Rect feuMagieMv[4];
        SDL_Rect glaceMagieMv[3];
        SDL_Rect bombeExplose[10];




        // Ce qui suit doit être initialisé et doit pouvoir être appelé
        // Pour le moment, non utilisable

        SDL_Rect PnjA[4][2]; // dimensions : x = 16 et y = 26 (64*52) ; E(1;29;37)
        SDL_Rect PnjB[4][2]; // dimensions : x = 21 et y = 26 (84*52) ; E(2)
        SDL_Rect PnjC[3]; // dimensions : x = 28 et y = 17 (84*17) ; E(3)
        SDL_Rect PnjD[3]; // dimensions : x = 16 et y = 17 (48*17) ; E(4;17)
        SDL_Rect PnjE[4][2]; // dimensions : x = 16 et y = 26 (77*52) -> (64*52) ; E(5)
        SDL_Rect PnjEArme[4]; // dimensions : fonction de l'orientation ; E(5)
        SDL_Rect PnjF[11]; // dimensions : x = 16 et y = 37 (176*37) ; E(6)
        SDL_Rect PnjG[4][2]; // dimensions : x = 16 et y = 16 (64*32) ; E(7)
        SDL_Rect PnjH[4][2]; // dimensions : x = 16 et y = 24 (64*48) ; E(8;9;16;30;41) P(11)
        SDL_Rect PnjI[2]; // dimensions : x = 16 et y = 16 (32*16) ; E(10;20)
        SDL_Rect PnjJ[4]; // dimensions : x = 16 et y = 21 (64*21) ; E(11)
        SDL_Rect PnjK[2][3]; // dimensions : x = 17 et y = 17 (34*51) ; E(12)
        SDL_Rect PnjL[3]; // dimensions : x = 32 et y = 15 (96*15) ; E(13)
        SDL_Rect PnjM[2]; // dimensions : x = 41 et y = 16 (82*16) ; E(14)
        SDL_Rect PnjN[4][3]; // dimensions : x = 24 et y = 31 (96*93) ; E(15)
        SDL_Rect PnjO[3]; // dimensions : x = 16 et y = 14 (48*14) ; E(18)
        SDL_Rect PnjP[3]; // dimensions : x = 64 et y = 32 (192*32) ; E(19 - BOSS)
        SDL_Rect PnjQ[2][2]; // dimensions : x = 16 et y = 15 (32*30) ; E(21)
        SDL_Rect PnjR[2]; // dimensions : x = 16 et y = 23 (32*23) ; E(22)
        SDL_Rect PnjS[2]; // dimensions : x = 26 et y = 17 (52*17) ; E(23)
        SDL_Rect PnjT[2]; // dimensions : x = 32 et y = 53 (64*53) ; E(24 - BOSS)
        SDL_Rect PnjU[4][2]; // dimensions : x = 28 et y = 30 (112*60) ; E(25)
        SDL_Rect PnjV[3]; // dimensions : x = 14 et y = 16 (42*16) ; E(26)
        SDL_Rect PnjW[4][4]; // dimensions : x = 16 et y = 17 (64*68) ; E(27)
        SDL_Rect PnjX[2]; // dimensions : x = 32 et y = 38 (64*38) ; E(28 - BOSS)
        SDL_Rect PnjY[4]; // dimensions : x = 32 et y = 32 (128*32) ; E(31 - BOSS)
        SDL_Rect PnjZ[4][2]; // dimensions : x = 16 et y = 23 (48*23) ; E(32)
        SDL_Rect PnjAA[4][2]; // dimensions : x = 22 et y = 25 (88*50) ; E(33;38)
        SDL_Rect PnjAB[4][2]; // dimensions : x = 24 et y = 25 (96*50) ; E(34;39)
        SDL_Rect PnjAC[3]; // dimensions : x = 32 et y = 32 (96*32) ; E(35 - BOSS)
        SDL_Rect PnjAD[3]; // dimensions : x = 54 et y = 42 (162*42) ; E(40 - BOSS)
        SDL_Rect PnjAE[2]; // dimensions : x = 26 et y = 19 (52*19) ; E(42)
        SDL_Rect PnjAF[4][3]; // dimensions : x = 32 et y = 32 (128*96) ; E(43 - BOSS)
        SDL_Rect PnjAG[4][2]; // dimensions : x = 22 et y = 26 (103*52) -> (88*52) ; E(44)
        SDL_Rect PnjAGArme[4]; // dimensions : fonction de l'orientation ; E(44)
        SDL_Rect PnjAH[4]; // dimensions : x = 69 et y = 76 (276*76) ; E(45 - BOSS)
        SDL_Rect PnjAI[4][2]; // dimensions : x = 22 et y = 27 (104*54) -> (88*54) ; E(46;47)       ----------------> OK : 146
        SDL_Rect PnjAIArme[4]; // dimensions : fonction de l'orientation ; E(46)
        SDL_Rect PnjAJ[4][2]; // dimensions : x = 22 et y = 27 (105*54) -> (88*54) ; E(48)          ----------------> OK : 148
        SDL_Rect PnjAJArme[4][2]; // dimensions : fonction de l'orientation ; E(48)
        SDL_Rect PnjAK[2][2]; // dimensions : x = 52 et y = 36 (104*72) ; E(50 - BOSS)
        SDL_Rect PnjAL[2]; // dimensions : x = 24 et y = 28 (48*28) ; E(51)
        SDL_Rect PnjAM[2][4]; // dimensions : x = 16 et y = 17 (32*68) ; E(52)

        SDL_Rect PnjAN[4][2]; // dimensions : x = 16 et y = 25 (64*50) ; P(1;13;14;23)
        SDL_Rect PnjAO[2]; // dimensions : x = 16 et y = 24 (16*48) ; P(2;18)
        SDL_Rect PnjAP[2][2]; // dimensions : x = 16 et y = 23 (32*46) ; P(3)
        SDL_Rect PnjAQ[4]; // dimensions : x = 16 et y = 17 (16*68) ; P(4)
        SDL_Rect PnjAR[4][2]; // dimensions : x = 17 et y = 16 (52*32) ; P(5)
        SDL_Rect PnjAS[2][2]; // dimensions : x = 15 et y = 16 (30*32) ; P(6)
        SDL_Rect PnjAT[2]; // dimensions : x = 16 et y = 25 (16*50) ; P(7;12;19;25)
        SDL_Rect PnjAU[2]; // dimensions : x = 16 et y = 23 (16*46) ; P(8;32)
        SDL_Rect PnjAV[2]; // dimensions : x = 16 et y = 27 (16*54) ; P(9)
        SDL_Rect PnjAW[4]; // dimensions : x = 16 et y = 26 (16*104) ; P(10;20)
        SDL_Rect PnjAX[4][2]; // dimensions : x = 16 et y = 23 (64*46) ; P(15)
        SDL_Rect PnjAY[2]; // dimensions : x = 32 et y = 48 (32*96) ; P(16)
        SDL_Rect PnjAZ[2]; // dimensions : x = 16 et y = 25 (18*50) ; P(17)
        SDL_Rect PnjBA[2]; // dimensions : x = 17 et y = 25 (17*50) ; P(21)
        SDL_Rect PnjBB[4]; // dimensions : x = 16 et y = 29 (16*116) ; P(22)
        SDL_Rect PnjBC[2]; // dimensions : x = 16 et y = 21 (16*42) ; P(24)
        SDL_Rect PnjBD[4]; // dimensions : x = 39 et y = 30 (39*120) ; P(26)
        SDL_Rect PnjBE[2]; // dimensions : x = 16 et y = 17 (16*34) ; P(27;30;31)
        SDL_Rect PnjBF[5]; // dimensions : x = 25 et y = 35 (25*175) ; P(28)
        SDL_Rect PnjBG[5]; // dimensions : x = 21 et y = 27 (21*135) ; P(29)
        SDL_Rect PnjBH[13]; // spin et explosions

        SDL_Rect police[10][10]; // Police de caractères
        SDL_Rect bordure[3][3]; // Bordure de texte

        // Objets récoltés
        SDL_Rect OR_Bombe;
        SDL_Rect OR_GrandeCle;
        SDL_Rect OR_PetiteCle;
        SDL_Rect OR_Parchemin;
        SDL_Rect OR_CoeurComplet;
        SDL_Rect OR_QuartDeCoeur;
        SDL_Rect OR_Boussole;
        SDL_Rect OR_Cristal;
        SDL_Rect OR_Lampe;
        SDL_Rect OR_BaguetteDeFeu;
        SDL_Rect OR_GrandeEpeePlantee;
        SDL_Rect OR_LivreVert;
        SDL_Rect OR_MedaillonRouge;
        SDL_Rect OR_Gant1;
        SDL_Rect OR_RubisVert[3];
        SDL_Rect OR_RubisBleu[3];
        SDL_Rect OR_PetiteEpeePlantee;
        SDL_Rect OR_Gant2;
        SDL_Rect OR_Palme;
        SDL_Rect OR_BaguetteDeGlace;
        SDL_Rect OR_MedaillonVert;
        SDL_Rect OR_FlecheArgent;
        SDL_Rect OR_RubisRouge[3];
        SDL_Rect OR_PetitCoeur;
        SDL_Rect OR_Fleche;
        SDL_Rect OR_PetiteReserveMagie;
        SDL_Rect OR_GrandeReserveMagie;
        SDL_Rect OR_Grappin;
        SDL_Rect OR_Maillet;
        SDL_Rect OR_Arc;
        SDL_Rect OR_MedaillonBleu;
        SDL_Rect OR_Bottes;
        SDL_Rect OR_Coupe[8];
        SDL_Rect OR_TuniqueBleue;
        SDL_Rect OR_TuniqueRouge;
        SDL_Rect OR_ArcArgent;
        SDL_Rect OR_Flute;
        SDL_Rect OR_Masque;
        SDL_Rect OR_Bourse;
        SDL_Rect OR_EpeeBleue;
        SDL_Rect OR_PetiteEpeeBlanche;
        SDL_Rect OR_PetitBouclier;
        SDL_Rect OR_FlaconVide;
        SDL_Rect OR_FlaconRouge;
        SDL_Rect OR_FlaconVert;
        SDL_Rect OR_FlaconBleu;
        SDL_Rect OR_Bouclier2;
        SDL_Rect OR_EpeeRouge;
        SDL_Rect OR_EpeeJaune;
        SDL_Rect OR_Bouclier3;
        SDL_Rect OR_PetiteEpeeBleue;
        SDL_Rect OR_TriForce;


        SDL_Rect O_PierreNoire;
        SDL_Rect O_BuissonVert;
        SDL_Rect O_BuissonMarron;
        SDL_Rect O_BuissonMauve;

        SDL_Rect O_Jarre;
        SDL_Rect O_PetiteTeteDeMort;
        SDL_Rect O_PierreGrise;
        SDL_Rect O_Pancarte;

        SDL_Rect O_JarreSurSocle;
        SDL_Rect O_PetiteTeteDeMortSurSocle;
        SDL_Rect O_PetitCoffreFerme;
        SDL_Rect O_PetitCoffreOuvert;

        SDL_Rect O_GrandCoffreOuvert;
        SDL_Rect O_GrandCoffreFerme;

        SDL_Rect O_GrosseTeteDeMort;
        SDL_Rect O_PancarteSurFondDesert;
        SDL_Rect O_PancarteSurFondVert;
        SDL_Rect O_PancarteSurFondMarron;

        position** refTileset; // Contient le code couleur de chaque tile du tileset de référence

    private:

};


#endif // IMAGESPARTIE_H_INCLUDED
