/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef JEU_H_INCLUDED
#define JEU_H_INCLUDED

#include "position.h"
#include "Generique.h"
#include "SelectionPartie.h"
#include "DeroulementPartie.h"

// Coordonne les diverses phase de jeu (générique, sélection de la partie, déroulement de la partie, appel ou enregistrement de l'état d'une partie...). Gère aussi les paramètres propres à l'affichage du jeu (taille de l'écran, nombre de fps...)
class Jeu
{
    public:

        Jeu();
        virtual ~Jeu();

        void miseAJour(SDL_Surface* screenJeu, Mix_Chunk* musique, bool* sortieProgramme);

    protected:

    private:

        Generique* gen; // Va gérer les différents générique du jeu (presentation, intro et fin)
        int compteurDebut; // Tempo utilisée pour le générique de début de jeu (à chaque lancement du programme) ---> A GERER AUTREMENT DIRECTEMENT DANS GENERIQUE
        SelectionPartie* selectPartie; // Menu de sélection de la partie (partie existante ou nouvelle)
        DeroulementPartie* partieEnCours; // Va gérer la partie en cours (une fois qu'elle aura été sélectionnée)
};



#endif // JEU_H_INCLUDED
