/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "Menu.h"

Menu::Menu()
{
    int i;

    for(i=0;i<4;i++) setEquipements(i,0);
    for(i=0;i<10;i++) setObjetsQuetes(i,false);

    setAffichageMenu(false);
    initSDLSurface(5);
    initSDLRect(5);

    setCurseurX(0);
    setCurseurY(0);
}

Menu::~Menu()
{
    freeMem(5);
}

void Menu::afficherCadreMenu(SDL_Surface* screenStatut,int pX,int pY,int dW,int dH)
{
    int i,j;
    SDL_Rect offset,image;

    // Affichage des diverse zones (bords et fond)
    for(i=0;i<dW;i++)
    {
        for(j=0;j<dH;j++)
        {
            offset.x = pX + i*16;
            offset.y = pY + j*16;

            if(i == 0)
            {
                if(j == 0) image = getSDLRect(23,0,0);
                else if(j == dH-1) image = getSDLRect(23,0,2);
                else image = getSDLRect(23,0,1);
            }
            else if (i == dW-1)
            {
                if(j == 0) image = getSDLRect(23,2,0);
                else if(j == dH-1) image = getSDLRect(23,2,2);
                else image = getSDLRect(23,2,1);
            }
            else
            {
                if(j == 0) image = getSDLRect(23,1,0);
                else if(j == dH-1) image = getSDLRect(23,1,2);
                else image = getSDLRect(23,1,1);
            }

        SDL_BlitSurface(bord, &image, screenStatut, &offset );

        }
    }


}

void Menu::afficherMenu(SDL_Surface* screenStatut)
{
    int i,j;
    SDL_Rect offset, offsetCurseur; // Pour spécifier la bonne position à l'écran;
    SDL_Rect image, curseur;

    // Affichage des cadres du menu
    afficherCadreMenu(screenStatut,20,20,9,9); // Items
    afficherCadreMenu(screenStatut,190,20,7,3); // Capacité en énergie
    afficherCadreMenu(screenStatut,190,84,7,9); // Equipements
    afficherCadreMenu(screenStatut,20,180,9,3); // Quêtes

    // Affichage du contenu de la zone de sélection Item
    for(i=0;i<4;i++)
    {
        for(j=0;j<4;j++)
        {
            offset.x = 34 + 31*i;
            offset.y = 40 + 29*j;

            offsetCurseur.x = offset.x - 8;
            offsetCurseur.y = offset.y - 8;

            // sélection de la bonne image
            if(i == 0 && j == 0)
            {
                switch(getValeurItem(i,j))
                {
                    case 1: // arc 1
                         image = getSDLRect(22,0,0);
                         break;
                    case 2: // arc 2
                         image = getSDLRect(22,0,5);
                         break;
                    default:
                        break;
                }
            }
            else if(i == 3 && j == 0)
            {
                switch(getValeurItem(i,j))
                {
                    case 1: // boomerang bleu
                         image = getSDLRect(22,3,0);
                         break;
                    case 2: // boomerang rouge
                         image = getSDLRect(22,3,4);
                         break;
                    default:
                        break;
                }
            }
            else if(i == 2 && j == 2)
            {
                switch(getValeurItem(i,j))
                {
                    case 1: // gant 1
                         image = getSDLRect(22,2,2);
                         break;
                    case 2: // gant 2
                         image = getSDLRect(22,2,5);
                         break;
                    default:
                        break;
                }
            }
            else if(i < 3 && j == 3)
            {
                switch(getValeurItem(i,j))
                {
                    case 1: // vide
                         image = getSDLRect(22,0,4);
                         break;
                    case 2: // rouge
                         image = getSDLRect(22,0,3);
                         break;
                    case 3: // vert
                         image = getSDLRect(22,1,3);
                         break;
                    case 4: // bleu
                         image = getSDLRect(22,2,3);
                         break;
                    case 5: // fée
                         image = getSDLRect(22,3,5);
                         break;
                    default:
                        break;
                }
            }
            else image = getSDLRect(22,i,j);

            // Affichage du curseur
            if (getValeurItem(i,j) > 0)
            {
                SDL_BlitSurface(inventaire, &image, screenStatut, &offset );

                if(i == getCurseurX() && j == getCurseurY())
                {
                    curseur = getSDLRect(24,0,0);
                    SDL_BlitSurface(bord, &curseur, screenStatut, &offsetCurseur );
                }
            }
            else
            {
                if(i == getCurseurX() && j == getCurseurY())
                {
                    curseur = getSDLRect(24,1,0);
                    SDL_BlitSurface(bord, &curseur, screenStatut, &offsetCurseur );
                }
            }
        }
    }

    // Affichage du contenu de la zone de visualisation équipements
    for(i=0;i<4;i++)
    {

    }

    // Affichage du contenu de la zone de visualisation de la capacité d'énergie (quarts de cœurs aquis sur le cœur à venir)
    for(i=0;i<4;i++)
    {

    }

    // Affichage du contenu de la zone de visualisation objets quêtes
    for(i=0;i<4;i++)
    {

    }

}

void Menu::setAffichageMenu(bool AM) {affichageMenu = AM;}
bool Menu::getAffichageMenu() {return affichageMenu;}

void Menu::setItems(int pX, int pY, int valeur) {items[pX][pY] = valeur;}
int Menu::getValeurItem(int pX, int pY) {return items[pX][pY];}

int Menu::getNumItem(int pX, int pY)
{
    int num;
    if(pY == 3 && pX < 3)
    {
        switch(getValeurItem(pX,pY))
        {
            case 1: // vide
                num = 17;
                break;
            case 2: // rouge
                num = 13;
                break;
            case 3: // vert
                num = 14;
                break;
            case 4: // bleu
                num = 15;
                break;
            case 5: // fée
                num = 24;
                break;
            default: // Rien (cas non utilisé)
                num = 22;
                break;
        }
    }
    else num = 1 + pX + 4*pY;

    return num;
}

void Menu::setEquipements(int pX, int valeur) {equipements[pX] = valeur;}
void Menu::setObjetsQuetes(int pX, bool etat) {objetsQuetes[pX] = etat;}

void Menu::setCurseurX(int CX) {curseurX = CX;}
int Menu::getCurseurX() {return curseurX;}

void Menu::setCurseurY(int CY) {curseurY = CY;}
int Menu::getCurseurY() {return curseurY;}

void Menu::mAJMenu(Hero* joueur)
{
    setItems(0,0,joueur->getListeItemsDisponibles(29));
    setItems(1,0,joueur->getListeItemsDisponibles(27));
    setItems(2,0,joueur->getListeItemsDisponibles(0));
    setItems(3,0,1); // Boomrang

    setItems(0,1,joueur->getListeItemsDisponibles(9));
    setItems(1,1,joueur->getListeItemsDisponibles(19));
    setItems(2,1,joueur->getListeItemsDisponibles(8));
    setItems(3,1,joueur->getListeItemsDisponibles(36));

    setItems(0,2,joueur->getListeItemsDisponibles(28));
    setItems(1,2,joueur->getListeItemsDisponibles(18));
    setItems(2,2,joueur->getListeItemsDisponibles(13));
    setItems(3,2,0); // filet à papillon

    setItems(0,3,0); // flacon 1
    setItems(1,3,0); // flacon 2
    setItems(2,3,0); // flacon 3
    setItems(3,3,joueur->getListeItemsDisponibles(11));

    /*
    joueur->setListeItemsDisponibles(29,ARC);
    joueur->setListeItemsDisponibles(27,GRAPPIN);
    joueur->setListeItemsDisponibles(0,BOMBE);
    //joueur->setListeItemsDisponibles(???,BOOMERANG);

    joueur->setListeItemsDisponibles(9,FEU);
    joueur->setListeItemsDisponibles(19,GLACE);
    joueur->setListeItemsDisponibles(8,LAMPE);
    joueur->setListeItemsDisponibles(36,FLUTE);

    joueur->setListeItemsDisponibles(28,MARTEAU);
    joueur->setListeItemsDisponibles(18,PALME);
    joueur->setListeItemsDisponibles(13,GANT);
    //joueur->setListeItemsDisponibles(???,FILET);

    //joueur->setListeItemsDisponibles(0,FLACON1);
    //joueur->setListeItemsDisponibles(0,FLACON2);
    //joueur->setListeItemsDisponibles(0,FLACON3);
    joueur->setListeItemsDisponibles(11,LIVRE);*/
}
