/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MENU_H
#define MENU_H

#include "position.h"
#include "ImagesPartie.h"
#include "Hero.h"

class Menu : public ImagesPartie
{
    public:
        Menu();
        virtual ~Menu();

        void afficherCadreMenu(SDL_Surface* screenStatut,int pX,int pY,int dW,int dH); // Factorisation de la fonction d'affichage des cadres du menu
        void afficherMenu(SDL_Surface* screenStatut); // Fonction en charge de l'affichage du menu
        void setAffichageMenu(bool AM);
        bool getAffichageMenu();
        void setItems(int pX, int pY, int valeur); // Permet de modifier les items affichés. Une valeur à 0 indique que l'item n'est pas affiché et n'est donc pas sélectionnable.
        int getValeurItem(int pX, int pY); // Fonction retournant une valeur représentative de la puissance de l'item sélectionné via le menu
        int getNumItem(int pX, int pY); // Fonction renvoyant le numéro de l'item sélectionné (arc, bombe, lampe...)
        void setEquipements(int pX, int valeur); // Permet d'afficher les équipements du joueur
        void setObjetsQuetes(int pX, bool etat); // Permet d'afficher les objets collectés pour la quête
        void setCurseurX(int CX);
        int getCurseurX();
        void setCurseurY(int CY);
        int getCurseurY();
        void mAJMenu(Hero* joueur);

    protected:

    private:
        bool affichageMenu; // Vrai si le menu doit être affiché
        int items[4][4]; // Tableau contenant un état représentatif de chaque arme ou item utilisable à tout moment lors de la partie.
        int equipements[4]; // Tableau contenant un état représentatif des équipements du joueur.
        bool objetsQuetes[10]; // Tableau indiquant les objets récoltés lors des quêtes
        int curseurX; // Position en X du curseur de sélection d'item
        int curseurY; // Position en Y du curseur de sélection d'item
};

#endif // MENU_H
