/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "Objet.h"

Objet::Objet()
{
    // Pour essai -> à adapter aux objets non récoltables
    initSDLSurface(4);
    initSDLRect(4);
    setEtat(0);
}

Objet::~Objet()
{

}

void Objet::setNumObjet(int NO) {numObjet = NO;}
int Objet::getNumObjet() {return numObjet;}

void Objet::setTypeObjetRecolte(int R) {typeObjetRecolte = R;}
int Objet::getTypeObjetRecolte() {return typeObjetRecolte;}

void Objet::setValeurObjetRecolte(int VOR) {valeurObjetRecolte = VOR;}
int Objet::getValeurObjetRecolte() {return valeurObjetRecolte;}

void Objet::setEtat(int E)
{
    // 0 -> inactif
    // 1 -> porté
    // 2 -> lancé
    // 3 -> explosé
    // 4 -> deplacement au sol
    etat = E;
}
int Objet::getEtat() {return etat;}

void Objet::setNumNarration(int NN) {numNarration = NN;}
int Objet::getNumNarration() {return numNarration;}

void Objet::initType()
{
    setFeuilleSprite(objets4);

    switch(getType())
    {
        /*case 7: // pancarte
        case 10: // coffre fermé
        case 11: // coffre ouvert
        case 15: // pancarte sur fond desert
        case 16: // pancarte sur fond vert
        case 17: // pancarte sur fond marron
            setDimensionX(16);
            setDimensionY(16);*/
        case 12: // Grand coffre ouvert
        case 13: // Grand coffre fermé
            setDimensionX(32);
            setDimensionY(32);
            break;

        default:
            setDimensionX(16);
            setDimensionY(16);
            break;
    }

}
SDL_Rect Objet::selectionSprite(bool pause)
{
    SDL_Rect sprite;

    // Gestion du compteur d'animation (incrémentation, pause et initialisation)
    if(!pause) setIncrCompteurAnim();

    switch(getEtat())
    {
        // Si l'objet explose
        case 3:

            switch(getType())
            {
                case 1: // Buissons
                case 2:
                case 3:
                    if(getCompteurAnim() == 1)
                    {
                        setDimensionX(27);
                        setDimensionY(43);
                        setPositionX(-5);
                        setPositionY(-13);
                    }
                    sprite = getSDLRect(20,getCompteurAnim()/12,getType()-1);
                    break;

                default: // explosion normale
                    if (getCompteurAnim() < 10) sprite = getSDLRect(36,0,0); // affichage d'une explosion d'objet
                    else if (getCompteurAnim() == 10)
                    {
                        sprite = getSDLRect(36,1,0); // affichage d'une explosion d'objet
                        setDimensionX(24);
                        setDimensionY(24);
                        setPositionX(-4);
                        setPositionY(-4);
                    }
                    else if (getCompteurAnim() < 15) sprite = getSDLRect(36,1,0); // affichage d'une explosion d'objet
                    else if (getCompteurAnim() == 15)
                    {
                        sprite = getSDLRect(36,2,0); // affichage d'une explosion d'objet
                        setDimensionX(32);
                        setDimensionY(32);
                        setPositionX(-4);
                        setPositionY(-4);
                    }
                    else sprite = getSDLRect(36,2,0); // affichage d'une explosion d'objet
                    break;

            }

            break;

        default:
            sprite = getSDLRect(400+getType(),0,0);
            break;

    }
    return sprite;
}
