/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef OBJET_H_INCLUDED
#define OBJET_H_INCLUDED

#include "Pnj.h"

// Comprend tout les objets de décors sur lesquels le héro est susceptible d'agir (pancartes, buissons portés, pierres portées, blocs qui glissent, coffres...)
class Objet : public Pnj
{
    public:

        Objet();
        virtual ~Objet();

        void setNumObjet(int NO);
        int getNumObjet();

        void setTypeObjetRecolte(int R);
        int getTypeObjetRecolte();

        void setValeurObjetRecolte(int VOR);
        int getValeurObjetRecolte();

        void setEtat(int E);
        int getEtat();

        void setNumNarration(int NN);
        int getNumNarration();

        void initType();
        SDL_Rect selectionSprite(bool pause);

    protected:

    private:

        int numObjet; // Numéro de l'objet. Permet de s'y référer plus simplement, notamment lors des sauvegardes/chargement de partie. Idéalement donc, ce numéro est unique sur une carte, quel que soit le type d'objet.
        int typeObjetRecolte; // Dans certains cas, porter ou détruire un objet peut en révéler un autre que l'on peut récolter
        int valeurObjetRecolte; // Renseigne sur la valeur de l'objet recolte
        int etat; // Etat de l'objet (inactif, porté, lancé, en déplacement au sol). Chaque type d'objet a uniquement certains états possibles
        int numNarration; // Dialogue associé à l'objet
};



#endif // OBJET_H_INCLUDED
