/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PERSONNAGE_H_INCLUDED
#define PERSONNAGE_H_INCLUDED

#include "Entite.h"

// Tout ce qui vit ou plus généralement qui se déplace sur la carte
class Personnage : public Entite
{
    public:

        Personnage();
        virtual ~Personnage();

        void setBougeHaut(bool H);
        bool getBougeHaut();

        void setBougeBas(bool B);
        bool getBougeBas();

        void setBougeGauche(bool G);
        bool getBougeGauche();

        void setBougeDroite(bool D);
        bool getBougeDroite();

        void gestionCollisions(int decalageFenetreX,int decalageFenetreY,position **table,bool personnageNonJoueur,bool testVertical, int vitessePersoSurX, int vitessePersoSurY); // Gestion des collisions avec correction automatique des déplacements

        void setImmobiliser();

        void setDeplacementDemandeParCorrection(bool DDPC);
        bool getDeplacementDemandeParCorrection();

        void setDeplacementRapide(bool DR);
        bool getDeplacementRapide();

        void setVitesseDeplacementSurX(int VDX);
        int getVitesseDeplacementSurX();

        void setVitesseDeplacementSurY(int VDY);
        int getVitesseDeplacementSurY();

        void setCompteurDeplacement(int CD);
        void incrementationCompteurDeplacement();
        int getCompteurDeplacement();

        void setDimensionXZoneCollision(int DXZC);
        int getDimensionXZoneCollision();
        void setDimensionYZoneCollision(int DYZC);
        int getDimensionYZoneCollision();

        void setDecalageXZoneCollision(int DXZC);
        int getDecalageXZoneCollision();
        void setDecalageYZoneCollision(int DYZC);
        int getDecalageYZoneCollision();

    protected:

        void gestionCollisionsHaut(int pX0, int pY0, position P0, position P1); // Partie de la gestion des collisions traitant les déplacements vers le haut
            void traitementDeplacementSuiteGestionCollisionsHaut(bool bloc0Traversable, bool bloc1Traversable, int pX0, position P0, position P1);
        void gestionCollisionsBas(int pX0, int pY0, position P0, position P1); // Partie de la gestion des collisions traitant les déplacements vers le bas
            void traitementDeplacementSuiteGestionCollisionsBas(bool bloc0Traversable, bool bloc1Traversable, int pX0, position P0, position P1);
        void gestionCollisionsGauche(int pX0, int pY0, position P0, position P1); // Partie de la gestion des collisions traitant les déplacements vers la gauche
            void traitementDeplacementSuiteGestionCollisionsGauche(bool bloc0Traversable, bool bloc1Traversable, int pY0, position P0, position P1);
        void gestionCollisionsDroite(int pX0, int pY0, position P0, position P1); // Partie de la gestion des collisions traitant les déplacements vers la droite
            void traitementDeplacementSuiteGestionCollisionsDroite(bool bloc0Traversable, bool bloc1Traversable, int pY0, position P0, position P1);

        bool deplacementVersLeHaut;
        bool deplacementVersLeBas;
        bool deplacementVersLaGauche;
        bool deplacementVersLaDroite;

        bool deplacementDemandeParCorrection; // vrai si c'est le système de gestion des collisions qui demande le déplacement dans une direction. Cet attribut devra être réinitialisé à faux à chaque nouvelle boucle.
        bool deplacementRapide; // Vrai lorsqu'un personnage doit courrir

        int vitesseSurX;
        int vitesseSurY;

        int compteurDeplacementAutomatique; // Compteur utilisé librement par chaque type de personnage afin de gérer ses déplacement automatiques.

        int dimensionXZoneCollision; // dimension sur X de la zone de collisions.
        int dimensionYZoneCollision; // dimension sur Y de la zone de collisions.
        int decalageXZoneCollision; // decalage sur X de la zone de collisions.
        int decalageYZoneCollision; // decalage sur Y de la zone de collisions.

    private:

};



#endif // PERSONNAGE_H_INCLUDED
