/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "Pnj.h"

Pnj::Pnj()
{
    setImmobiliser();

    // Par défaut, les PNJ regardent vers le bas
    setOrientation(1);

    // Initialisation des SDL_Rect spécifiques aux PNJ
    initSDLRect(1);
    initSDLRect(4);

    // Pour test
    setPauseAnimation(true);

    initCompteurAnim();
    setCompteurDeplacement(-1);
}

Pnj::~Pnj()
{

}

void Pnj::setDecalageXAvecLeHero(int X) {decalageXAvecLeHero = getPositionX() - X;}
int Pnj::getDecalageXAvecLeHero() {return decalageXAvecLeHero;}

void Pnj::setDecalageYAvecLeHero(int Y) {decalageYAvecLeHero = getPositionY() - Y;}
int Pnj::getDecalageYAvecLeHero() {return decalageYAvecLeHero;}

void Pnj::intelligenceArtificielle()
{

}

void Pnj::traitementDeplacementsPNJ(position** table,int decalageFenetreX,int decalageFenetreY)
{
    // Demandes de déplacement ; Afin de corriger un bug et de réduire le nombre d'opérations, le traitement des déplacements n'est effectué que lorsque le PNJ est affiché (bug constaté : des PNJ peuvent sortir de la carte et faire planter le programme).
    if(getPositionX() - decalageFenetreX >= - getDimensionX()/2 && getPositionX() - decalageFenetreX <= LARGEUR_ECRAN + getDimensionX()/2 && getPositionY() - decalageFenetreY >= - getDimensionY()/2 && getPositionY() - decalageFenetreY <= HAUTEUR_ECRAN - getDimensionY()/2)
    {
        // Correction des déplacements demandés
        gestionCollisions(0,0,table,true,true,getVitesseDeplacementSurX(),getVitesseDeplacementSurY());
        gestionCollisions(0,0,table,true,false,getVitesseDeplacementSurX(),getVitesseDeplacementSurY());

        // Décrochage du mode attaque sur le PNJ ennemi ne se déplace plus en direction du joueur
        // PARTIE A REVOIR
        if(!getBougeHaut() && !getBougeBas() && !getBougeGauche() && !getBougeDroite()) setAttaque(false);

        // Application des déplacements demandés
        //if(getVitesseDeplacementSurY() == 1 && getVitesseDeplacementSurX() == 1 && getCompteurDeplacement()%2 != 0) // permet de réduire encore par 2 la vitesse de déplacement des ennemis s'il s sont déjà à leur vitesse de placement minimale sur Y
        if(getCompteurDeplacement()%2 == 0) // permet de réduire encore par 2 la vitesse de déplacement des ennemis s'il s sont déjà à leur vitesse de placement minimale sur Y
        {
            if(getBougeHaut()){setPositionY(-getVitesseDeplacementSurY());}
            if(getBougeBas()) {setPositionY(getVitesseDeplacementSurY());}
            if(getBougeGauche()) {setPositionX(-getVitesseDeplacementSurX());}
            if(getBougeDroite()) {setPositionX(getVitesseDeplacementSurX());}
        }

        // Gestion de l'orientation des PNJ selon que l'on se trouve en mode attaque ou non.
        if(!getAttaque()) // Protection pour eviter que l'ennemi (si c'est cette classe de PNJ que l'on traite) change d'orientation constament dans certains cas (s'il est bloqué et qu'il fait l'objet de corrections de déplacement par le système de gestion des collisions)
        {

            if (getBougeBas() && !getBougeDroite() && !getBougeGauche() && !getBougeHaut()) setOrientation(1);
            if (!getBougeBas() && getBougeDroite() && !getBougeGauche() && !getBougeHaut()) setOrientation(3);
            if (!getBougeBas() && !getBougeDroite() && getBougeGauche() && !getBougeHaut()) setOrientation(2);
            if (!getBougeBas() && !getBougeDroite() && !getBougeGauche() && getBougeHaut()) setOrientation(0);
        }
        else
        {
            if (pow(getDecalageXAvecLeHero(),2) < pow(getDecalageYAvecLeHero(),2) && getDecalageYAvecLeHero() > 0) setOrientation(0);
            if (pow(getDecalageXAvecLeHero(),2) < pow(getDecalageYAvecLeHero(),2) && getDecalageYAvecLeHero() < 0) setOrientation(1);
            if (pow(getDecalageXAvecLeHero(),2) > pow(getDecalageYAvecLeHero(),2) && getDecalageXAvecLeHero() > 0) setOrientation(2);
            if (pow(getDecalageXAvecLeHero(),2) > pow(getDecalageYAvecLeHero(),2) && getDecalageXAvecLeHero() < 0) setOrientation(3);
        }
    }
}


// Mode attaque et sélectionSprite : fonctions virtuelles
bool Pnj::getAttaque() {return false;}
void Pnj::setAttaque(bool A) {}
SDL_Rect Pnj::selectionSprite(bool pause)
{
    SDL_Rect sprite;
    return sprite;
}
