/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PNJ_H_INCLUDED
#define PNJ_H_INCLUDED

#include "Personnage.h"

// Personnages Non Joueurs
class Pnj : public Personnage
{
    public:

        Pnj();
        virtual ~Pnj();

        void setDecalageXAvecLeHero(int X);
        int getDecalageXAvecLeHero();

        void setDecalageYAvecLeHero(int Y);
        int getDecalageYAvecLeHero();

        virtual void intelligenceArtificielle();
        void traitementDeplacementsPNJ(position** table,int decalageFenetreX,int decalageFenetreY); // Traite les déplacement automatiques des PNJ en fonction de leur IA propre et des collisions

        virtual bool getAttaque();
        virtual void setAttaque(bool A);
        virtual SDL_Rect selectionSprite(bool pause);

    protected:

        int decalageXAvecLeHero; // Decalage sur X entre le PNJ et le hero
        int decalageYAvecLeHero; // Decalage sur Y entre le PNJ et le hero

    private:
};



#endif // PNJ_H_INCLUDED
