/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PROJECTILE_H_INCLUDED
#define PROJECTILE_H_INCLUDED

#include "position.h"
#include "Pnj.h"

// Projectiles emis par les items du héro ou les armes ennemies et ayant une durée de vie limitée et/ou un déplacement propre (flèches, lances, bombes, boomerang, etc...).
class Projectile : public Pnj
{
    public:

        Projectile();
        virtual ~Projectile();

        void initType(SDL_Surface* P);
        void intelligenceArtificielle();
        SDL_Rect selectionSprite(bool pause);

        void setPuissance(int P);
        int getPuissance();

        void setTimeToLive(int TTL);
        int getTimeToLive();

        void setArretProjectile(bool AP);
        bool getArretProjectile();

    protected:

    private:

        int timeToLive; // Durée de vie du projectile. Le projectile doit être détruit au plus tard une fois sa durée de vie maximale dépassée.
        int puissance; // Puissance du projectile
        bool arretProjectile; // Indique à l'IA que le projectile est arrêté
};

#endif // PROJECTILE_H_INCLUDED
