/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SELECTIONPARTIE_H_INCLUDED
#define SELECTIONPARTIE_H_INCLUDED

#include "position.h"
#include "Clavier.h"
#include "Carte.h"
#include "ImagesPartie.h"
#include "Texte.h"

// Gère le menu de sélection de la partie
class SelectionPartie : public ImagesPartie
{
    public:

        SelectionPartie();
        virtual ~SelectionPartie();

        void setNumero(int N);
        int getNumero();

        void setCurseurSurEffacerPartie(bool CSEP);
        bool getCurseurSurEffacerPartie();

        void setMenuSelectionActif(bool MSA);
        bool getMenuSelectionActif();
        void afficherMenuSelectionActif(SDL_Surface* screenMenuSelectionPartie,bool* sortieProgramme);

        void setMenuCreationNouvellePartie(bool MCNP);
        bool getMenuCreationNouvellePartie();
        void afficherMenuCreationNouvellePartie(SDL_Surface* screenMenuCreationNouvellePartie, bool* sortieProgramme);

        void setMenuOptionsPartie(bool MOP);
        bool getMenuOptionsPartie();
        void afficherMenuOptionsPartie(SDL_Surface* screenMenuOptionsPartie,bool* sortieProgramme);

        void setMenuSuppressionPartie(bool MSP);
        bool getMenuSuppressionPartie();
        void afficherMenuSuppressionPartie(SDL_Surface* screenMenuSuppressionPartie,bool* sortieProgramme);

        void setPositionXCurseurLettre(int PXCL);
        int getPositionXCurseurLettre();
        void setPositionYCurseurLettre(int PYCL);
        int getPositionYCurseurLettre();

    protected:

    private:

        void lectureSauvegardes(int* nbCoeurs, string* nomJ, int numPartie);
        void initSauvegarde();

        int numero; // Numéro de la partie en cours
        bool curseurSurEffacerPartie; // Dans le menu de sélection de partie, indique que le curseur se trouve face à l'option de suppression d'une partie.

        bool menuSelectionActif; // indique si le menu de sélection de partie doit être affiché ou non (vrai si affiché)
        bool menuOptionsPartie; // Indique qu'il faut afficher le menu d'options
        bool menuCreationNouvellePartie; // Indique qu'il faut afficher le menu permettant de créer une nouvelle partie
        bool menuSuppressionPartie; // Indique qu'il faut afficher le menu de suppression de partie
        Clavier clav; // Gère les actions liées aux événements clavier dans le menu de sélection partie
        SDL_Event event; // Pour la gestion des événements SDL
        Carte mapMenu; // Le menu de sélection de partie est vu comme une carte du jeu et est construit de la même manière
        Carte mapCreationPartie; // Le menu de creation de partie est vu comme une carte du jeu et est construit de la même manière

        // IMPORTANT : à placer dans image partie
        SDL_Rect rectPointeur[2]; // Pour sélectionner la bonne image du personnage à placer
        SDL_Rect rectPointeurHero; // Pour placer le personnage au bon endroit sur l'écran
        SDL_Rect rectCoeur[3]; // Pour sélectionner le cœur à afficher sur les trois possibles
        SDL_Rect rectPositionCoeur[3][20]; // Pour chaque partie (3 possibles), jusqu'à 20 cœurs possibles.
        SDL_Rect rectCadre[10]; //
        SDL_Rect rectPositionCadre[20][15]; //

        int nbCoeursPartie[3]; // Contient le nombre de cœurs max que peut avoir le joueur sur chaque partie
        string nomJoueur[3]; // Contient le nom du joueur de chaque sauvegarde

        SDL_Surface* pointeurHero; // Icone du héro servant à indiquer quelle partie choisir (se place en face de la partie)
        SDL_Surface* imageCoeur; // Image des cœurs d'énergie.
        SDL_Surface* imageCadre; //

        Texte texteMenu; // Textes dans le menu

        int positionXCurseurLettre; // Dans le sous menu de création de partie, indique la position X du curseur permettant de choisir une lettre.
        int positionYCurseurLettre; // Dans le sous menu de création de partie, indique la position Y du curseur permettant de choisir une lettre.
};



#endif // SELECTIONPARTIE_H_INCLUDED
