/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "Statut.h"

Statut::Statut()
{
    initSDLSurface(5);
    initSDLRect(5);

    //setJaugeMagieDoublee(false);
}

Statut::~Statut()
{
    freeMem(5);
}

// Affichage du statut du héro (cœurs, magie, armes, etc...)
void Statut::afficherStatut(SDL_Surface* screenStatut)
{
    int i,j;

    // Jauge de magie pleine
    SDL_Rect imageJaugePleineLink = getSDLRect(11,1,-1);
    SDL_Rect offsetJaugePleine;
    offsetJaugePleine.x = 6;
    offsetJaugePleine.y = 8;
    SDL_BlitSurface(statut, &imageJaugePleineLink, screenStatut, &offsetJaugePleine );

    // Jauge de magie vide
    SDL_Rect imageJaugeLink = getSDLRect(11,0,-1);
    SDL_Rect offsetJauge;
    offsetJauge.x = 6;
    offsetJauge.y = 8;
    if (getJaugeMagieDoublee()) imageJaugeLink.h = 37 - getQuantiteMagie(); // 37 <-> 5 ==> 32
    else imageJaugeLink.h = 37 - 2*getQuantiteMagie(); // 37 <-> 5 ==> 32
    SDL_BlitSurface(statut, &imageJaugeLink, screenStatut, &offsetJauge );

    // Inscription "1/2" sous la jauge de magie
    SDL_Rect offsetDemi;
    SDL_Rect imageDemi = getSDLRect(12,-1,-1);
    offsetDemi.x = 6;
    offsetDemi.y = 4;
    if (getJaugeMagieDoublee()) SDL_BlitSurface(statut, &imageDemi, screenStatut, &offsetDemi );

    // Cadre dans lequel est indiqué l'objet actif
    SDL_Rect offsetCadre;
    SDL_Rect imageCadre = getSDLRect(13,0,-1);
    offsetCadre.x = 28;
    offsetCadre.y = 6;
    SDL_BlitSurface(statut, &imageCadre, screenStatut, &offsetCadre );

    // Objet actif à afficher dans le cadre
    SDL_Rect offsetItem;
    SDL_Rect imageItem;
    switch(getNumItem())
    {
        case 1:
            switch(getValeurItem())
            {
                case 1:
                    imageItem = getSDLRect(22,0,0);
                    break;
                case 2:
                    imageItem = getSDLRect(22,0,5);
                    break;
                default:
                    break;
            }
            break;

        case 2:
            imageItem = getSDLRect(22,1,0);
            break;

        case 3:
            imageItem = getSDLRect(22,2,0);
            break;

        case 4:
            switch(getValeurItem())
            {
                case 1:
                    imageItem = getSDLRect(22,3,0);
                    break;
                case 2:
                    imageItem = getSDLRect(22,3,4);
                    break;
                default:
                    break;
            }
            break;

        case 5:
            imageItem = getSDLRect(22,0,1);
            break;

        case 6:
            imageItem = getSDLRect(22,1,1);
            break;

        case 7:
            imageItem = getSDLRect(22,2,1);
            break;

        case 8:
            imageItem = getSDLRect(22,3,1);
            break;

        case 9:
            imageItem = getSDLRect(22,0,2);
            break;

        case 10:
            imageItem = getSDLRect(22,1,2);
            break;

        case 11:
            switch(getValeurItem())
            {
                case 1:
                    imageItem = getSDLRect(22,2,2);
                    break;
                case 2:
                    imageItem = getSDLRect(22,2,5);
                    break;
                default:
                    break;
            }
            break;

        case 12:
            imageItem = getSDLRect(22,3,2);
            break;

        case 13:
        case 14:
        case 15:
            switch(getValeurItem())
            {
                case 1:
                    imageItem = getSDLRect(22,0,4);
                    break;
                case 2:
                    imageItem = getSDLRect(22,0,3);
                    break;
                case 3:
                    imageItem = getSDLRect(22,1,3);
                    break;
                case 4:
                    imageItem = getSDLRect(22,2,3);
                    break;
                case 5:
                    imageItem = getSDLRect(22,3,5);
                    break;
                default:
                    break;
            }
            break;

        case 16:
            imageItem = getSDLRect(22,3,3);
            break;

        default:
            imageItem = getSDLRect(22,1,5);
            break;
    }
    offsetItem.x = offsetCadre.x + 3;
    offsetItem.y = offsetCadre.y + 3;
    SDL_BlitSurface(inventaire, &imageItem, screenStatut, &offsetItem );

    // Icone rubis
    SDL_Rect offsetRubis;
    SDL_Rect imageRubis = getSDLRect(14,-1,-1);
    offsetRubis.x = 90;
    offsetRubis.y = 6;
    SDL_BlitSurface(statut, &imageRubis, screenStatut, &offsetRubis );

    // Nombre de rubis du joueur
    affichageNumerique(screenStatut, 82, 16, getNbRubis(), 3);

    // Icone bombe
    SDL_Rect offsetBombe;
    SDL_Rect imageBombe = getSDLRect(15,-1,-1);
    offsetBombe.x = 120;
    offsetBombe.y = 6;
    SDL_BlitSurface(statut, &imageBombe, screenStatut, &offsetBombe );

    // Nombre de bombes du joueur
    affichageNumerique(screenStatut, 116, 16, getNbBombes(), 2);

    // Icone arc
    SDL_Rect offsetArc;
    SDL_Rect imageArc = getSDLRect(16,0,-1);
    offsetArc.x = 147;
    offsetArc.y = 6;
    SDL_BlitSurface(statut, &imageArc, screenStatut, &offsetArc );

    // Nombre de flêches dont dispose le joueur
    affichageNumerique(screenStatut, 147, 16, getNbFleches(), 2);

    // Icone petite clé
    SDL_Rect offsetCle;
    SDL_Rect imageCle = getSDLRect(17,-1,-1);
    offsetCle.x = 180;
    offsetCle.y = 6;
    SDL_BlitSurface(statut, &imageCle, screenStatut, &offsetCle );

    // Nombre de clés du joueur (valables uniquement dans le donjon où se trouve le joueur)
    affichageNumerique(screenStatut, 180, 16, getNbCles(), 1);

    // Gestion de l'affichage "vie" au dessus des cœurs
    SDL_Rect offsetVie;
    SDL_Rect imageVie = getSDLRect(18,-1,-1);
    offsetVie.x = 250;
    offsetVie.y = 4;
    SDL_BlitSurface(statut, &imageVie, screenStatut, &offsetVie );

    // Gestion des cœurs d'énergie du héro
    SDL_Rect offsetCoeurs;
    SDL_Rect imageCoeur;
    for (i=0;i<getNbCoeursMax();i++)
    {
        offsetCoeurs.x = 222 + 9*(i%10);
        offsetCoeurs.y = 15 + (i/10)*9;

        // Permet de sélectionner la bonne image de cœur
        if (i < getNbCoeurs()) {j = 0;}
        //else if (getNbCoeurs()%2 == 1 && i == getNbCoeurs()/2) {j = 1;}
        else {j = 2;}

        imageCoeur = getSDLRect(19,j,0);
        SDL_BlitSurface(statut, &imageCoeur, screenStatut, &offsetCoeurs );
    }

}

void Statut::affichageNumerique(SDL_Surface* screenStatut, int X, int Y, int valeur, int nbDigit)
{
    int i, digit;
    SDL_Rect offesetChiffres;
    SDL_Rect offset;

    for(i=0;i<nbDigit;i++)
    {
        // Détermination de la valeur du digit à afficher
        if(i==nbDigit-3) digit = valeur/100;
        else if(i==nbDigit-2) digit = (valeur/10)%10;
        else digit = valeur%10;

        // Recherche du digit dans la feuille de sprites
        if(digit<5) offesetChiffres = getSDLRect(30,digit,0);
        else offesetChiffres = getSDLRect(30,digit-5,1);

        offset.x = X + i*8;
        offset.y = Y;

        SDL_BlitSurface(chiffres, &offesetChiffres, screenStatut, &offset );
    }
}

void Statut::setNbCoeurs(int NC) {nbCoeurs = NC;}
int Statut::getNbCoeurs() {return nbCoeurs;}

void Statut::setNbCoeursMax(int NCM) {nbCoeursMax = NCM;}
int Statut::getNbCoeursMax() {return nbCoeursMax;}

void Statut::setNumItem(int NI) {numItem = NI;}
int Statut::getNumItem() {return numItem;}

void Statut::setValeurItem(int VI) {valeurItem = VI;}
int Statut::getValeurItem() {return valeurItem;}

void Statut::setNbRubis(int NR) {nbRubis = NR;}
int Statut::getNbRubis() {return nbRubis;}

void Statut::setNbBombes(int NB) {nbBombes = NB;}
int Statut::getNbBombes() {return nbBombes;}

void Statut::setNbFleches(int NF) {nbFleches = NF;}
int Statut::getNbFleches() {return nbFleches;}

void Statut::setNbCles(int NC) {nbCles = NC;}
int Statut::getNbCles() {return nbCles;}

void Statut::setQuantiteMagie(int QM) {quantiteMagie = QM;}
int Statut::getQuantiteMagie() {return quantiteMagie;}

void Statut::setJaugeMagieDoublee(bool JMD) {jaugeMagieDoublee = JMD;}
bool Statut::getJaugeMagieDoublee() {return jaugeMagieDoublee;}
