/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef STATUT_H_INCLUDED
#define STATUT_H_INCLUDED

#include "position.h"
#include "ImagesPartie.h"

// Affichage des informations de statut du joueurs à l'écran (énergie, magie, item en cours, quantité rubis, bombes, flèches, clés...)
class Statut : public ImagesPartie
{
    public:

        Statut();
        virtual ~Statut();

        void afficherStatut(SDL_Surface* screenStatut);
        void affichageNumerique(SDL_Surface* screenStatut, int X, int Y, int valeur, int nbDigit);

        void setNbCoeurs(int NC);
        int getNbCoeurs();

        void setNbCoeursMax(int NCM);
        int getNbCoeursMax();

        void setNumItem(int NI);
        int getNumItem();

        void setValeurItem(int VI);
        int getValeurItem();

        void setNbRubis(int NR);
        int getNbRubis();

        void setNbBombes(int NB);
        int getNbBombes();

        void setNbFleches(int NF);
        int getNbFleches();

        void setNbCles(int NC);
        int getNbCles();

        void setQuantiteMagie(int QM);
        int getQuantiteMagie();

        void setJaugeMagieDoublee(bool JMD);
        bool getJaugeMagieDoublee();

    protected:

    private:

        int nbCoeurs; // Nombre de cœurs à afficher (de 0 au nombre max de cœurs possibles)
        int nbCoeursMax; // Nombre de cœurs disponibles au maximum (de 3 à 20 selon l'avancement dans la partie)
        int numItem; // Item actif à afficher dans le cadre
        int valeurItem; // Valeur représentative de la puissance de l'item sélectionné.
        int nbRubis; // Stock l'information du nombre de rubis à afficher
        int nbBombes; // Stock l'information du nombre de bombes à afficher
        int nbFleches; // Stock l'information du nombre de fleches à afficher
        int nbCles; // Stock l'information du nombre de cles à afficher
        int quantiteMagie; // Quantité de magie du joueur dont il dispose encore
        bool jaugeMagieDoublee; // Indique si la jauge de magie est doublée
};



#endif // STATUT_H_INCLUDED
