/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef TEXTE_H_INCLUDED
#define TEXTE_H_INCLUDED

#include "position.h"
#include "ImagesPartie.h"

// Classe gérant le texte et son affichage
class Texte : public ImagesPartie
{
    public:

        Texte();
        virtual ~Texte();

        void setNumTexte(int NT);
        int getNumTexte();

        void setPageSuivante();
        int getPage();

        void setFinAffichageTexte(bool FAT);
        bool getFinAffichageTexte();

        void setFinAffichagePage(bool FAP);
        bool getFinAffichagePage();

        void setAutorisationAffichageTexte(bool AAT);
        bool getAutorisationAffichageTexte();

        void afficherTexte(SDL_Surface* screenTexte);
        void afficherTexteSelectionPartie(SDL_Surface* screen, string nom1, string nom2, string nom3, string nomMenu, string nouveau, string effacer);
        void afficherTexteCreationNouvellePartie(SDL_Surface* screen, string nomMenu, string nomJoueur, int X, int Y);
        void gestionLettres(SDL_Surface* screen, string Txt, SDL_Rect rect, int k);

        void setNarratif(bool N);
        bool getNarratif();

    protected:

    private:

        string getTexte(int NT);

        int numTexte; // Numéro du texte à afficher. Si -1, pas de texte à afficher.
        int page; // Indique quelle page du texte afficher
        bool finAffichageTexte; // Indique si le texte a été affiché en intégralité
        bool finAffichagePage; // Vrai si la page est affichée complètement
        bool autorisationAffichageTexte; // Vrai si l'on est autorisé à afficher le texte
        int compteurAffichageLettreParLettre; // Compteur permettant de gérer le défilement des lettres
        bool narratif; // Chaque texte est au choix narratif ou non (et donc, s'il doit s'afficher lettre à lettre ou directement)
        SDL_Rect rectTexte[26][6]; // Position à l'écran de chaque lettre du texte et de son cadre
        SDL_Rect rectTexteSelectionPartie[8][6]; // Pour placer les lettres des noms de joueur mémorisés dans les sauvegardes, ainsi que les autres textes composant le menu de sélection de partie.
        SDL_Rect rectTexteCreationNouvellePartie[13][6]; // Pour placer les lettres à afficher dans le menu de création de nouvelle partie
};


#endif // TEXTE_H_INCLUDED
