/*
    This program is a clone of Zelda 3
    Copyright (C) 2012  Frédéric Micout - fred@sujets-libres.fr

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "position.h"
#include "Jeu.h"

using namespace std;

int main ( int argc, char** argv )
{

    int tempsActuel, tempsPrecedent = 0;
    int fps = 50; // 50

    // Créer une nouvelle fenêtre
	SDL_Surface* fenetre = SDL_SetVideoMode(640, 480, 32, SDL_HWSURFACE | SDL_FULLSCREEN);
	//SDL_Surface* fenetre = SDL_SetVideoMode(640, 480, 32, SDL_SWSURFACE);
	SDL_Surface* screen = SDL_CreateRGBSurface(SDL_SWSURFACE, LARGEUR_ECRAN, HAUTEUR_ECRAN, 32, 0, 0, 0, 0);
	SDL_Surface* screenX2 = NULL;

    // Pour ne pas aficher le pointer de la souris
    SDL_ShowCursor(SDL_DISABLE);

    // prepare SDL
	SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO);

	// Gestion des erreurs liées à l'init de la lib sdl_mixer
	if(Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, 1024) == -1) //Initialisation de l'API Mixer
	{
        cout << Mix_GetError() << endl;
	}
	Mix_AllocateChannels(10); // 10 canaux utilisés
	Mix_Volume(1, MIX_MAX_VOLUME/3); // musique de fond
	Mix_Volume(2, MIX_MAX_VOLUME/10); //
	Mix_Volume(3, MIX_MAX_VOLUME/10);
	Mix_Volume(4, MIX_MAX_VOLUME/20);

	Mix_Chunk *musique; // Création du pointeur de type Mix_Chunk
	musique = Mix_LoadWAV("musique/Selection.ogg"); //Chargement de la musique
    Mix_PlayChannel(1,musique, -1); //Jouer infiniment la musique

    // CREATION D'UN NOUVEAU JEU (dans lequel on va pouvoir choisir une partie ou en créer une)
    Jeu* jeu = new Jeu();

    bool done = false;
    while (!done)
    {
        // Effacer "screen"
        SDL_FillRect(screen, 0, SDL_MapRGB(screen->format, 0, 0, 0));

        // mise à jour "screen"
        jeu->miseAJour(screen, musique, &done);

        // Gestion des FPS
        do
        {
            tempsActuel = SDL_GetTicks();
            SDL_Delay(2);
        }
        while(tempsActuel<tempsPrecedent+(950/fps));
        tempsPrecedent = tempsActuel;

        // Modifie la taille de l'écran
        SDL_FreeSurface(screenX2);
        screenX2 = zoomSurface (screen, 2, 2, 0);

        SDL_BlitSurface(screenX2, NULL, fenetre, NULL);

        // Mise à jour de l'écran
        SDL_Flip(fenetre);
    }

    delete jeu;

    // Pour quitter proprement le programme
	SDL_FreeSurface(screen);
	SDL_FreeSurface(screenX2);
	SDL_FreeSurface(fenetre);

    SDL_ShowCursor(SDL_ENABLE);

    // Musique (fin)
    Mix_FreeChunk(musique); //Libération de la musique
    Mix_CloseAudio(); //Fermeture de l'API

	SDL_Quit();

    return 0;
}
